/* ****************************************************************************
   **                                                                        **
   **                                 BANQUE                                 **
   **      (c) Copyright 01-08-1998 par FlashCode (Sebastien HELLEU)         **
   **                                                                        **
   **                        http://www.flashtux.org                         **
   **                      e-mail: flashcode@flashtux.org                    **
   **                                                                        **
   ****************************************************************************

==== This program is free software; you can redistribute it and/or modify
==== it under the terms of the GNU General Public License as published by
==== the Free Software Foundation; either version 2 of the License, or
==== (at your option) any later version.
====
==== This program is distributed in the hope that it will be useful,
==== but WITHOUT ANY WARRANTY; without even the implied warranty of
==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
==== GNU General Public License for more details.
====
==== You should have received a copy of the GNU General Public License
==== along with this program; if not, write to the Free Software
==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@flashtux.org>
Creation: 01/08/1998
*/


// ========== INCLUDES ==========

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <malloc.h>
#include <math.h>

#ifdef MSDOS
    #include <conio.h>
    #include <dos.h>
    #include <sys\farptr.h>
    #include <dpmi.h>
    #include <pc.h>
    #include <sys\movedata.h>
#else
    #include <stdarg.h>
    #include <time.h>
    #include <termios.h>
    #include <sys/times.h>
    #include <sys/types.h>
    #include <unistd.h>
    #include <asm/ioctls.h>
    #define __need_timeval
    #include <bits/time.h>
#endif

// ========== CONSTANTES ==========

// general

#define VERSION_HI      1
#define VERSION_LOW     0

#define COPYRIGHT       "BANQUE  v0.1  (c) 01/08/98 --> 21/09/98  par Sbastien HELLEU  [-FlashCode-]"

#define NB_MAX_OP       10000
#define NB_MAX_UNDO     999

#define SOLDE_REEL      0
#define SOLDE_BANQUE    1

#define SCROLL_HAUT     1
#define SCROLL_BAS      2

#define MONTANT_INF         0
#define MONTANT_INF_EGAL    1
#define MONTANT_EGAL        2
#define MONTANT_SUP         3
#define MONTANT_SUP_EGAL    4

#define MONNAIE_FRANCS      0
#define MONNAIE_EUROS       1

#define RECHERCHE_LOCALE    0
#define RECHERCHE_GLOBALE   1

// codes UNDO

// si opration supprime (Ctrl+Suppr):
    #define U_RECREER_OP        1
// si opration insre (Inser):
    #define U_EFFACER_OP        2
// si date modifie (Enter, + ou -):
    #define U_RESTAURER_DATE    3
// si libell modifi (Enter):
    #define U_MODIFIER_LIBELLE  4
// si libell supprim (Suppr):
    #define U_RESTAURER_LIBELLE 5
// si montant modifi (Enter):
    #define U_MODIFIER_MONTANT  6
// si montant supprim (Suppr):
    #define U_RESTAURER_MONTANT 7
// si operation dpointe (A):
    #define U_REPOINTER         8
// si operation pointe (P):
    #define U_DEPOINTER         9
// si champ recopi (Espace):
    #define U_ANNULER_RECOPIER  10

// macros

#define POS_LIGNE   3+(pos_op-op_debut)

// couleurs

#ifdef MSDOS
    #define BLACK           0
    #define BLUE            1
    #define GREEN           2
    #define CYAN            3
    #define RED             4
    #define MAGENTA         5
    #define BROWN           6
    #define LIGHTGRAY       7
    #define DARKGRAY        8
    #define LIGHTBLUE       9
    #define LIGHTGREEN      10
    #define LIGHTCYAN       11
    #define LIGHTRED        12
    #define LIGHTMAGENTA    13
    #define YELLOW          14
    #define WHITE           15
#else
    #define BLACK           0
    #define RED             1
    #define GREEN           2
    #define BROWN           3
    #define BLUE            4
    #define MAGENTA         5
    #define CYAN            6
    #define LIGHTGRAY       7
    #define DARKGRAY        8
    #define LIGHTRED        9
    #define LIGHTGREEN      10
    #define YELLOW          11
    #define LIGHTBLUE       12
    #define LIGHTMAGENTA    13
    #define LIGHTCYAN       14
    #define WHITE           15
#endif

// touches

#ifdef MSDOS
    #define K_ECHAP     27
    #define K_RETURN    13
    #define K_BACKSPACE 8
#else
    #define K_ECHAP     227
    #define K_RETURN    13
    #define K_BACKSPACE 127
#endif

#define K_BAS       300
#define K_HAUT      301
#define K_GAUCHE    302
#define K_DROITE    303

#define K_F1        304
#define K_F2        305
#define K_F3        306
#define K_F4        307
#define K_F5        308
#define K_F6        309
#define K_F7        310
#define K_F8        311
#define K_F9        312
#define K_F10       313
#define K_F11       314
#define K_F12       315

#define K_INSER     316
#define K_SUPPR     317
#define K_HOME      318
#define K_END       319
#define K_PGUP      320
#define K_PGDN      321

// ========== VARIABLES ==========

static char id[] = "$Id: BANQUE (c) Copyright 2001/08/26 by FlashCode <flashcode@free.fr> $";

#ifdef MSDOS
    short   video;
#else
    struct termios  ot0, ot1, nt0, nt1;
#endif

int     coul_texte = LIGHTGRAY;
int     coul_fond  = BLACK;

int     shift = 0, control = 0, alt = 0;

int     x_curseur, y_curseur;

int     c_champ_normal[2]     = { LIGHTGRAY,  YELLOW     };
int     c_champ_normal_f[2]   = { BLACK,      BLACK      };
int     c_champ_actif[2]      = { WHITE,      YELLOW     };
int     c_champ_actif_f[2]    = { MAGENTA,    MAGENTA    };
int     c_solde_fin_mois[2]   = { WHITE,      WHITE      };
int     c_solde_bnq[2]        = { GREEN,      GREEN      };
int     c_solde_bnq_actif[2]  = { LIGHTGREEN, LIGHTGREEN };
int     c_solde_reel[2]       = { CYAN,       CYAN       };
int     c_solde_reel_actif[2] = { LIGHTCYAN,  LIGHTCYAN  };
int     c_op_active[2]        = { LIGHTGRAY,  YELLOW     };
int     c_op_active_f[2]      = { RED,        RED        };
int     c_edition             = YELLOW;
int     c_edition_f           = BLUE;
int     c_modif               = LIGHTGREEN;
int     c_modif_f             = BROWN;

int     nb_lignes_source =
            #include "nb_lig.txt"
            ;

// -------------------------------

unsigned char   fichier_compte[256];

typedef struct
{
    unsigned char   couleur;
    unsigned char   jour;
    unsigned char   mois;
    short           annee;
    unsigned char   pointe;
    unsigned char   libelle[27];
    double          montant;
} t_op;

typedef struct
{
    int             u_code;
    int             u_no_op;
    int             u_old_no_op;
    unsigned char   u_op_creee;
    t_op            u_op;
} t_undo;

t_op        op[NB_MAX_OP];      // les operations sur le compte
int         nb_op;              // nombre d'operations crees
double      solde_apres[NB_MAX_OP]; // solde (reel ou banque) apres chaque operation
short       SL_no_op[NB_MAX_OP];  // pour l'affichage d'une sous-liste: references
                                  // des operations
short       SL_nb_op;           // nombre de lignes selectionnees pour la
                                // sous-liste
int         deb_op_aff;         // 1ere operation a afficher
int         pos_op;             // numero d'operation en surbrillance
int         pos_champ;          // champ actif (date, pointe, libelle, ...)
int         op_debut;           // numero de l'operation en haut de l'ecran
char        type_solde;         // type de solde affiche a droite (reel ou banque)
double      solde_reel;         // solde du compte
double      solde_banque;       // solde du compte en comptant les pointes seulement
int         nb_non_pointes;     // nombre d'operations non pointees
double      somme_non_pointes;  // somme des operations non pointees

int         nb_mark;            // nombre d'operations marquees
double      somme_mark;         // somme des operations marquees

unsigned char   euro = 0;
double          taux_euro = 6.55957;

int         modif;              // 1 si modif(s) depuis dernire sauvegarde

int         jour_systeme, mois_systeme, annee_systeme;

int         x_champ[5] = { 1, 14, 18, 46, 70 };

int             nb_jours[12] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
unsigned char   nom_mois[12][10] =
                    { "Janvier", "Fvrier", "Mars", "Avril",
                      "Mai", "Juin", "Juillet", "Aout", "Septembre", "Octobre",
                      "Novembre", "Dcembre" };

int         nb_libelles;

t_undo      undo[NB_MAX_UNDO];  // les modifications effectues (permet l'annulation des dernires)
int         nb_undo;            // nombre de modifications effectues
int         nb_max_undo_depasse;// capacit maxi du nombre d'undo dpass

unsigned char   fonction_sous_liste = 0;    // vaut 1 des que sous_liste a ete
                                            // appelee au moins une fois

int         accents;            // = 1 si on veut bien des accents, 0 sinon

// ============================================================================
// ============================================================================

// supprime_accents: supprime tous les accents dans une chaine de caracteres

void supprime_accents(char *chaine)
{
    int     i, longueur;

    longueur = strlen(chaine);
    for (i = 0; i < longueur; i++)
        switch (chaine[i])
        {
            case '':
            case '':
            case '':
            case '':
                chaine[i] = 'e';
                break;
            case '':
                chaine[i] = 'a';
                break;
            case '':
                chaine[i] = 'c';
                break;
            case '':
            case '':
                chaine[i] = 'i';
                break;
            case '':
                chaine[i] = 'o';
                break;
            case '':
                chaine[i] = 'u';
                break;
            // *****************
            case '': // barrre verticale
                chaine[i] = '|';
                break;
            case '': // T
                chaine[i] = '=';
                break;
            case '': // double barre horizontale
                chaine[i] = '=';
                break;
        }
}

// mon_printf: ecrit un texte en supprimant eventuellement les accents

void mon_printf(unsigned char *chaine, ...)
{
    unsigned char   buffer[256];
    va_list         argptr;

    va_start(argptr, chaine);
    vsprintf(buffer, chaine, argptr);
    va_end(argptr);
    if (!accents)
        supprime_accents(buffer);
    printf(buffer);
}

// affiche_aide_ligne_cmd: aide en ligne de commande (NON IMPLEMENTE)

void affiche_aide_ligne_cmd()
{
    mon_printf("\n");
    mon_printf(COPYRIGHT);
    mon_printf("\n\n");
    exit(0);
}

// traite_params: traitement des parametres de ligne de commande

void traite_params(int argc, unsigned char *argv[])
{
    int     i;

    for (i = 1; i < argc; i++)
    {
        if ( (strcmp(argv[i], "/?") == 0) || (strcmp(argv[i], "-?") == 0) )
            affiche_aide_ligne_cmd();
        if (strcasecmp(argv[i], "-e") == 0)
            accents = 0;
    }
}

#ifdef MSDOS
    void __crt0_glob_function()
    {
    }

    void __crt0_load_environment_file()
    {
    }

    void __crt0_setup_arguments()
    {
    }
#endif

#ifndef MSDOS

// init_ecran_ansi: initialise l'ecran pour l'affichage par ANSI sous Linux VT/100

void init_ecran_ansi()
{
    tcgetattr(0, &ot0); tcgetattr(0, &nt0);
    tcgetattr(1, &ot1); tcgetattr(1, &nt1);

    nt0.c_lflag = 0;
    nt0.c_iflag = 0;
    nt0.c_oflag = 0;
    nt0.c_cc[VMIN] = 1;
    nt0.c_cc[VTIME] = 0;

    tcsetattr(0, TCSANOW, &nt0);

    nt1.c_lflag = 0;
    nt1.c_iflag = 0;
    nt1.c_oflag = 0;
    nt1.c_cc[VMIN] = 1;
    nt1.c_cc[VTIME] = 0;

    tcsetattr(1, TCSANOW, &nt1);
}

// deinit_ecran_ansi:

void deinit_ecran_ansi()
{
    tcsetattr(0, TCSANOW, &ot0);
    tcsetattr(1, TCSANOW, &ot1);
}
#endif

#ifndef MSDOS
time_t      secondes_ecoulees;
struct tm   *date_du_jour = NULL;
#endif

// lit_date_systeme: lit la date systeme

void lit_date_systeme()
{
    #ifdef MSDOS
    struct date     dat;
    #endif

    #ifdef MSDOS
        getdate(&dat);
        jour_systeme = dat.da_day;
        mois_systeme = dat.da_mon;
        annee_systeme = dat.da_year;
    #else
        secondes_ecoulees = time(NULL);
        if (date_du_jour == NULL)
            date_du_jour = (struct tm *)malloc(sizeof(struct tm));
        date_du_jour = localtime(&secondes_ecoulees);
        jour_systeme = date_du_jour->tm_mday;
        mois_systeme = date_du_jour->tm_mon+1;
        annee_systeme = date_du_jour->tm_year+1900;
    #endif
}

// mon_getch: attend l'appui sur une touche et renvoie le code de la touche appuyee

int mon_getch()
{
    unsigned char   key;

    #ifndef MSDOS
    fd_set          rfds;
    struct timeval  tv;
    int             retval;
    unsigned char   touches[10];
    unsigned char   touche_ptr, i;
    int             s = 6;
    #endif

    #ifdef MSDOS
        shift = 0; control = 0; alt = 0;
        key = getch();
        if (key == 0)
        {
            key = getch();
            switch (key)
            {
                case 'H':return K_HAUT;
                case 'P':return K_BAS;
                case 'K':return K_GAUCHE;
                case 'M':return K_DROITE;
                case  14:alt = 1; return K_BACKSPACE;
                case  18:alt = 1; return 'E';    // Alt-"E"
                case  22:alt = 1; return 'U';    // Alt-"U"
                case '-':alt = 1; return 'X';    // Alt-"X"
                case  48:alt = 1; return 198;    // Alt-"B"
                case  50:alt = 1; return 159;    // Alt-"M"
                case  78:alt = 1; return '+';    // Alt-"+"
                case  74:alt = 1; return '-';    // Alt-"-"
                case ';':return K_F1;
                case '<':return K_F2;
                case '=':return K_F3;
                case '>':return K_F4;
                case '?':return K_F5;
                case '@':return K_F6;
                case 'A':return K_F7;
                case 'B':return K_F8;
                case 'C':return K_F9;
                case 'D':return K_F10;
                case 133:return K_F11;
                case 134:return K_F12;
                case  82:return K_INSER;
                case  83:return K_SUPPR;
                case  71:return K_HOME;
                case  79:return K_END;
                case  73:return K_PGUP;
                case  81:return K_PGDN;
                case 141:control = 1; return K_HAUT;
                case 145:control = 1; return K_BAS;
                case 147:control = 1; return K_SUPPR;
                case 152:alt = 1; return K_HAUT;
                case 160:alt = 1; return K_BAS;
            }
            return key;   // autre touche speciale --> ignoree
        }
        if (key == 10)
        {
            control = 1;
            return K_RETURN;
        }
        if ( (key == 12) || (key == 18) || (key == 21) )
            control = 1;
        return key;
    #else
        read(0, &key, 1);

        shift = 0; control = 0; alt = 0;
        if (ioctl(0, TIOCLINUX, &s) == 0)
        {
            if (s & 1) shift = 1;
            if (s & 4) control = 1;
            if (s & 10) alt = 1;
        }

        if (key != 27) return key;

        touches[0] = 0;
        touche_ptr = 0;
        retval = 1;

        while (retval != 0)
        {
            FD_ZERO(&rfds);
            FD_SET(0, &rfds);
            tv.tv_sec = 0;
            tv.tv_usec = 0;
            retval = select(1, &rfds, NULL, NULL, &tv);
            if (retval)
            {
                read(0, &key, 1);
                touches[touche_ptr++] = key;
            }
        }

/*        for (i = 0; i < touche_ptr; i++)
            printf("%03d ", touches[i]);
        printf("\r\n"); */
        switch (touches[0])
        {
            case 0:
                return 227;
            case 91:
                switch (touches[1])
                {
                    case 91:
                        switch (touches[2])
                        {
                            case 65:return K_F1;
                            case 66:return K_F2;
                            case 67:return K_F3;
                            case 68:return K_F4;
                            case 69:return K_F5;
                        }
                        break;
                    case 49:
                        switch (touches[2])
                        {
                            case 55:
                                if (touches[3] == 126) return K_F6;
                                break;
                            case 56:
                                if (touches[3] == 126) return K_F7;
                                break;
                            case 57:
                                if (touches[3] == 126) return K_F8;
                                break;
                            case 126:return K_HOME;
                        }
                        break;
                    case 50:
                        switch (touches[2])
                        {
                            case 48:
                                if (touches[3] == 126) return K_F9;
                                break;
                            case 49:
                                if (touches[3] == 126) return K_F10;
                                break;
                            case 51:
                                if (touches[3] == 126) return K_F11;
                                break;
                            case 52:
                                if (touches[3] == 126) return K_F12;
                                break;
                            case 126:return K_INSER;
                        }
                        break;
                    case 51:
                        if (touches[2] == 126) return K_SUPPR;
                        break;
                    case 52:
                        if (touches[2] == 126) return K_END;
                        break;
                    case 53:
                        if (touches[2] == 126) return K_PGUP;
                        break;
                    case 54:
                        if (touches[2] == 126) return K_PGDN;
                        break;
                    case 65:return K_HAUT;
                    case 66:return K_BAS;
                    case 67:return K_DROITE;
                    case 68:return K_GAUCHE;
                }
        }
        return touches[touche_ptr-1]+100;
    #endif
}

// print_xy_c: ecrit un texte aux coordonnees (x,y) en couleur

void print_xy_c(int x, int y, int coul, int fond, unsigned char *chaine, ...)
{
    unsigned char   buffer[81], buffer2[121];
    va_list         argptr;
    #ifdef MSDOS
    unsigned int    ofs, attr, i;
    #endif

    va_start(argptr, chaine);
    vsprintf(buffer, chaine, argptr);
    va_end(argptr);
    if (!accents)
        supprime_accents(buffer);
    x_curseur = x;
    y_curseur = y;
    #ifdef MSDOS
        coul_texte = coul;
        coul_fond = fond;
        attr = (coul+(fond <<4)) << 8;
        ofs = (y-1)*160+(x-1)*2;
        i = 0;
        while (buffer[i])
        {
            _farpokew(video, ofs, attr+buffer[i]);
            ofs += 2;
            i++;
        }
    #else
        if (coul & 0x08)
            sprintf(buffer2, "\x1b[%i;%iH\x1b[1;3%d;4%dm%s", y, x, coul & 7, fond, buffer);
        else
            sprintf(buffer2, "\x1b[%i;%iH\x1b[0;3%d;4%dm%s", y, x, coul, fond, buffer);
        write(1, buffer2, strlen(buffer2));
    #endif
    x_curseur = x+strlen(buffer);
    if (x_curseur > 79) { x_curseur -= 80; y_curseur++; }
}

// print_xy: ecrit un texte aux coordonnees (x,y) avec la couleur courante

void print_xy(int x, int y, unsigned char *chaine, ...)
{
    unsigned char   buffer[81], buffer2[121];
    va_list         argptr;
    #ifdef MSDOS
    unsigned int    ofs, attr, i;
    #endif

    va_start(argptr, chaine);
    vsprintf(buffer, chaine, argptr);
    va_end(argptr);
    if (!accents)
        supprime_accents(buffer);
    x_curseur = x;
    y_curseur = y;
    #ifdef MSDOS
        attr = (coul_texte+(coul_fond << 4)) << 8;
        ofs = (y-1)*160+(x-1)*2;
        i = 0;
        while (buffer[i])
        {
            _farpokew(video, ofs, attr+buffer[i]);
            ofs += 2;
            i++;
        }
    #else
        sprintf(buffer2, "\x1b[%i;%iH%s", y, x, buffer);
        write(1, buffer2, strlen(buffer2));
    #endif
    x_curseur = x+strlen(buffer);
    if (x_curseur > 79) { x_curseur -= 80; y_curseur++; }
}

// print: ecrit un texte aux coordonnees courantes avec la couleur courante

void print(unsigned char *chaine, ...)
{
    unsigned char   buffer[81];
    va_list         argptr;
    #ifdef MSDOS
    unsigned int    ofs, attr, i;
    #endif

    va_start(argptr, chaine);
    vsprintf(buffer, chaine, argptr);
    va_end(argptr);
    if (!accents)
        supprime_accents(buffer);
    #ifdef MSDOS
        attr = (coul_texte+(coul_fond << 4)) << 8;
        ofs = (y_curseur-1)*160+(x_curseur-1)*2;
        i = 0;
        while (buffer[i])
        {
            _farpokew(video, ofs, attr+buffer[i]);
            ofs += 2;
            i++;
        }
    #else
        write(1, buffer, strlen(buffer));
    #endif
    x_curseur += strlen(buffer);
    if (x_curseur > 79) { x_curseur -= 80; y_curseur++; }
}

// clrtoeol: efface du curseur jusqu'a la fin de la ligne

void clrtoeol()
{
    int     i, ofs, nb_car, valeur;

    #ifdef MSDOS
        nb_car = 81-x_curseur;
        valeur = ((coul_texte+(coul_fond << 4)) << 8)+' ';
        ofs = (y_curseur-1)*160+(x_curseur-1)*2;
        for (i = 0; i < nb_car; i++)
        {
            _farpokew(video, ofs, valeur);
            ofs += 2;
        }
    #else
        print("\x1b[K");
    #endif
}

// setcolor: fixe la couleur d'ecriture (caractere et fond)

void setcolor(int coul, int fond)
{
    #ifdef MSDOS
        coul_texte = coul;
        coul_fond = fond;
    #else
        if (coul & 0x08)
            print("\x1b[1;3%d;4%dm", coul & 7, fond);
        else
            print("\x1b[0;3%d;4%dm", coul, fond);
    #endif
}

// _gotoxy: deplace le curseur aux coordonnees (x,y)

void _gotoxy(int x, int y)
{
    unsigned char   buffer[81];

    #ifdef MSDOS
        _go32_dpmi_registers regs;
    #endif

    x_curseur = x;
    y_curseur = y;
    #ifdef MSDOS
        regs.x.ax = 0x0200;
        regs.h.dl = x-1;
        regs.h.dh = y-1;
        regs.x.bx = 0;
        regs.x.ss = 0;
        regs.x.sp = 0;
        _go32_dpmi_simulate_int(0x10, &regs);
    #else
        sprintf(buffer, "\x1b[%i;%iH", y, x);
        write(1, buffer, strlen(buffer));
    #endif
}

// clearscreen: efface l'ecran

void clearscreen()
{
    #ifdef MSDOS
        int     i;

        for (i = 1; i <= 25; i++)
        {
            _gotoxy(1, i);
            clrtoeol();
        }
        x_curseur = 1;
        y_curseur = 1;
        _gotoxy(1, 1);
        //clrscr();
    #else
        x_curseur = 1;
        y_curseur = 1;
        // print("\x1b[0;10m\x1b[2J\x1b[1;1H");
        print("\x1b[2J\x1b[1;1H");
    #endif
}

void scroll(int y1, int y2, int direction)
{
    int     i, deb, fin;

    #ifdef MSDOS
        deb = (y1-1)*160;
        fin = (y2-2)*160;
        if (direction == SCROLL_HAUT)
            movedata(video, y1*160, video, (y1-1)*160, (y2-y1)*160);
        else
            for (i = y2-2; i >= y1-1; i--)
                movedata(video, i*160, video, (i+1)*160, 160);
            //movedata(video, (y1-1)*160, video, y1*160, (y2-y1)*160);
    #else
        if (direction == SCROLL_HAUT)
            print("\x1b[0m\x1b[%i;%ir\x1b[%i;1H\x1b\x44\x1b[0;0r", y1, y2, y2);
        else
            print("\x1b[0m\x1b[%i;%ir\x1b[%i;1H\x1b\x4d\x1b[0;0r", y1, y2, y1);
    #endif
}

// ----------------------------------------------------------------------------

// message_fin: message en sortie du programme

void message_fin()
{
    setcolor(LIGHTGRAY, BLACK);
    clearscreen();
    mon_printf(COPYRIGHT);
    mon_printf("\n\n%u lignes de code source en C++...", nb_lignes_source);
    #ifdef MSDOS
        mon_printf("\n\n-- Version MsDos -- (disponible galement sous Linux)\n\n");
    #else
        mon_printf("\n\n-- Version Linux -- (disponible galement sous MsDos)\n\n");
    #endif
    mon_printf("BANQUE:\n");
    mon_printf("  - saisie rapide des oprations\n");
    mon_printf("  - gestion des pointages d'oprations\n");
    mon_printf("  - annulations multiples\n");
    mon_printf("  - recherche instantane selon plusieurs critres\n");
    mon_printf("  - double monnaie: Francs / Euros\n");
    mon_printf("  - soldes partiels\n");
    mon_printf("  - ...\n\n");
    mon_printf("Auteur: Sbastien HELLEU\n");
    mon_printf("        flashcode@free.fr\n");
    mon_printf("        http://flashcode.free.fr\n");
    #ifndef MSDOS
        mon_printf("\n");
    #endif
}

// ----------------------------------------------------------------------------

// affiche_pos: affiche la position de la barre de selection et le nombre
//              de modifications effectuees

void affiche_pos()
{
    print_xy_c(26, 25, BLUE, LIGHTGRAY, "%5d", nb_mark);
    print_xy_c(31, 25, BLACK, LIGHTGRAY, " mark = ");
    if (euro)
        print_xy_c(39, 25, BLUE, LIGHTGRAY, "%-10.2f", somme_mark/taux_euro);
    else
        print_xy_c(39, 25, BLUE, LIGHTGRAY, "%-10.2f", somme_mark);
    if (pos_op == nb_op)
        print_xy_c(51, 25, BLUE, LIGHTGRAY, "-----");
    else
        print_xy_c(51, 25, BLUE, LIGHTGRAY, "%5d", pos_op+1);
    print_xy_c(56, 25, BLACK, LIGHTGRAY, " / ");
    setcolor(BLUE, LIGHTGRAY);
    print_xy(59, 25, "%-5d", nb_op);
    print_xy(59, 25, "%-5d", nb_op);
    setcolor(BLUE, LIGHTGRAY);
    if (modif)
        print_xy(64, 25, "*");
    else
        print_xy(64, 25, " ");
    print_xy_c(67, 25, BLACK, LIGHTGRAY, "M:");
    if (nb_undo > 0)
        print_xy_c(70, 25, BLUE, LIGHTGRAY, "%-3d", nb_undo);
    else
        print_xy_c(70, 25, BLUE, LIGHTGRAY, "-  ");
    _gotoxy(x_champ[pos_champ], POS_LIGNE);
}

// affiche_touches: affiche les touches en bas de l'ecran

void affiche_touches()
{
    _gotoxy(1, 25);
    setcolor(  RED, LIGHTGRAY); print(" F1 ");
    setcolor(BLACK, LIGHTGRAY); print("Aide ");
    /*setcolor(  RED, LIGHTGRAY); print(" F2 ");
    setcolor(BLACK, LIGHTGRAY); print("Sauver "); */
    setcolor(  RED, LIGHTGRAY); print(" Alt+X ");
    setcolor(BLACK, LIGHTGRAY);
    print("Quitter                                                         ");
    if (euro)
        print_xy_c(74, 25, BLUE, LIGHTGRAY, " EUROS");
    else
        print_xy_c(74, 25, BLUE, LIGHTGRAY, "FRANCS");
    affiche_pos();
}

// affiche_statut: affiche les statuts en haut (soldes, ...)

void affiche_statut(int tout)
{
    if (euro)
    {
        print_xy_c(14, 1, GREEN, BLUE, "%-10.2f", solde_reel/taux_euro);
        print_xy_c(40, 1, GREEN, BLUE, "%-10.2f", solde_banque/taux_euro);
        if (tout)
        {
            print_xy_c(50, 1, CYAN, BLUE, "%4d", nb_non_pointes);
            print_xy_c(70, 1, GREEN, BLUE, "%-10.2f", somme_non_pointes/taux_euro);
        }
    }
    else
    {
        print_xy_c(14, 1, GREEN, BLUE, "%-10.2f", solde_reel);
        print_xy_c(40, 1, GREEN, BLUE, "%-10.2f", solde_banque);
        if (tout)
        {
            print_xy_c(50, 1, CYAN, BLUE, "%4d", nb_non_pointes);
            print_xy_c(70, 1, GREEN, BLUE, "%-10.2f", somme_non_pointes);
        }
    }
}

// ----------------------------------------------------------------------------

// montant_en_chaine: renvoie une chaine a partir d'un montant

void montant_en_chaine(unsigned char *chaine, double montant)
{
    int     i;

    if (montant == 0)
        strcpy(chaine, "0");
    else
    {
        sprintf(chaine, "%.8f", montant);
        i = strlen(chaine)-1;
        while (chaine[i] == '0') chaine[i--] = '\0';
        if (chaine[i] == '.') chaine[i] = '\0';
    }
}

// ============================================================================

void erreur_format_fichier()
{
    setcolor(LIGHTGRAY, BLACK);
    print_xy(1, 1, "Erreur en lecture du fichier des donnees 'banque.dat'.");
    print_xy(1, 2, "Compte reinitialise.");
    print_xy(1, 3, "Appuyez sur une touche pour continuer...");
    mon_getch();
    lit_date_systeme();
    op[0].jour = jour_systeme; op[0].mois = mois_systeme;
    op[0].annee = annee_systeme;
    op[0].pointe = 1; op[0].montant = 100; strcpy(op[0].libelle, "*** Depart ***");
    pos_op = 1; pos_champ = 0; nb_op = 1; op_debut = 0;
}

/*void charge_compte()
{
    FILE            *F;
    unsigned char   chaine[101];

    type_solde = SOLDE_REEL;
    if ((F = fopen("banque.dat", "rt")) == NULL)
    {
        setcolor(LIGHTGRAY, BLACK);
        print_xy(1, 1, "Fichier des donnees 'banque.dat' introuvable.");
        print_xy(1, 2, "Compte reinitialise.");
        print_xy(1, 3, "Appuyez sur une touche pour continuer...");
        mon_getch();
        lit_date_systeme();
        op[0].couleur = 0;
        op[0].jour = jour_systeme; op[0].mois = mois_systeme;
        op[0].annee = annee_systeme;
        op[0].pointe = 1; op[0].montant = 100; strcpy(op[0].libelle, "*** Depart ***");
        pos_op = 1; pos_champ = 0; nb_op = 1; op_debut = 0;
        return;
    }
//    fread(&nb_op, sizeof(nb_op), 1, F);
//    fread(op, sizeof(t_op), nb_op, F);
    nb_op = 0;
    while (fgets(chaine, 100, F) != NULL)
    {
        op[nb_op].couleur = 0;
        sscanf(chaine, "%d/%d/%d",
            &op[nb_op].jour, &op[nb_op].mois, &op[nb_op].annee);
        op[nb_op].pointe = (chaine[strlen(chaine)-2] == '*');
        if (fgets(chaine, 100, F) == NULL)
        {
            erreur_format_fichier();
            fclose(F);
            return;
        }
        chaine[strlen(chaine)-1] = '\0';
        strcpy(op[nb_op].libelle, chaine);
        if (fgets(chaine, 100, F) == NULL)
        {
            erreur_format_fichier();
            fclose(F);
            return;
        }
        chaine[strlen(chaine)-1] = '\0';
        op[nb_op].montant = atof(chaine);
        nb_op++;
    }
    pos_op = nb_op;
    if (nb_op > 21) op_debut = nb_op-21; else op_debut = 0;
    pos_champ = 0;
    fclose(F);
}*/

void compte_introuvable()
{
    setcolor(LIGHTGRAY, BLACK);
    print_xy(1, 1, "Fichier des donnees 'banque.dat' introuvable.");
    print_xy(1, 2, "Compte reinitialise.");
    print_xy(1, 3, "Appuyez sur une touche pour continuer...");
    mon_getch();
    lit_date_systeme();
    op[0].couleur = 0;
    op[0].jour = jour_systeme; op[0].mois = mois_systeme;
    op[0].annee = annee_systeme;
    op[0].pointe = 1; op[0].montant = 100; strcpy(op[0].libelle, "*** Depart ***");
    pos_op = 1; pos_champ = 0; nb_op = 1; op_debut = 0; deb_op_aff = 0;
    nb_mark = 0; somme_mark = 0;
    euro = 0; type_solde = SOLDE_REEL;
    strcpy(fichier_compte, "banque.dat");
}

void charge_compte(unsigned char *argv0)
{
    FILE            *F;
    int             i;
    unsigned char    *pos;

    strcpy(fichier_compte, "banque.dat");
    if ((F = fopen(fichier_compte, "rb")) == NULL)
    {
        strcpy(fichier_compte, argv0);
        #ifdef MSDOS
            pos = strrchr(fichier_compte, '\\');
        #else
            pos = strrchr(fichier_compte, '/');
        #endif
        if (pos == NULL)
        {
            compte_introuvable();
            return;
        }
        strcpy(pos+1, "banque.dat");
        if ((F = fopen(fichier_compte, "rb")) == NULL)
        {
            compte_introuvable();
            return;
        }
    }
//    fread(&nb_op, sizeof(nb_op), 1, F);
//    fread(op, sizeof(t_op), nb_op, F);
    fread(&type_solde, sizeof(type_solde), 1, F);
    if ( (type_solde != 0) && (type_solde != 1) )
        type_solde = 0;
    fread(&euro, sizeof(euro), 1, F);
    if ( (euro != 0) && (euro != 1) )
        euro = 0;
    fread(&deb_op_aff, sizeof(deb_op_aff), 1, F);
    fread(&nb_op, sizeof(nb_op), 1, F);
    fread(op, sizeof(t_op), nb_op, F);
    if (deb_op_aff > nb_op-1)
        deb_op_aff = 0;
    pos_op = nb_op;
    if (nb_op > 21) op_debut = nb_op-21; else op_debut = 0;
    pos_champ = 0;
    nb_mark = 0; somme_mark = 0;
    for (i = 0; i < nb_op; i++)
        if (op[i].couleur != 0)
        {
            nb_mark++;
            somme_mark += op[i].montant;
        }
    fclose(F);
}

/*int sauve_compte()
{
    FILE            *F;
    int             i;
    unsigned char   chaine[101];

    #ifdef MSDOS
    #else
        system("mv banque.dat banque.bak >/dev/null 2>/dev/null");
    #endif
    if ((F = fopen("banque.dat", "wt")) == NULL)
    {
        print_xy_c(1, 25, BLACK, LIGHTGRAY,
            "Erreur d'ecriture du fichier 'banque.dat'");
        return 0;
    }
    print_xy_c(1, 25, BLACK, LIGHTGRAY,
        " Sauvegarde du compte dans 'banque.dat'...");

    for (i = 0; i < nb_op; i++)
    {
        if (op[i].pointe)
            sprintf(chaine, "%02d/%02d/%04d *\n",
                op[i].jour, op[i].mois, op[i].annee);
        else
            sprintf(chaine, "%02d/%02d/%04d\n",
                op[i].jour, op[i].mois, op[i].annee);
        fputs(chaine, F);
        sprintf(chaine, "%s\n", op[i].libelle);
        fputs(chaine, F);
        montant_en_chaine(chaine, op[i].montant);
        strcat(chaine, "\n");
        fputs(chaine, F);
    }
    fclose(F);
    modif = 0;
    affiche_touches();
    _gotoxy(x_champ[pos_champ], POS_LIGNE);
    return 1;
} */

int sauve_compte()
{
    FILE            *F;
    int             i;
    unsigned char   chaine[101];

    #ifdef MSDOS
    #else
        //system("mv banque.dat banque.bak >/dev/null 2>/dev/null");
    #endif
    if ((F = fopen(fichier_compte, "wb")) == NULL)
    {
        print_xy_c(1, 25, BLACK, LIGHTGRAY,
            "Erreur d'ecriture du fichier '%s'", fichier_compte);
        return 0;
    }
    print_xy_c(1, 25, BLACK, LIGHTGRAY,
        " Sauvegarde du compte dans 'banque.dat'...");

    fwrite(&type_solde, sizeof(type_solde), 1, F);
    fwrite(&euro, sizeof(euro), 1, F);
    fwrite(&deb_op_aff, sizeof(deb_op_aff), 1, F);
    fwrite(&nb_op, sizeof(nb_op), 1, F);
    fwrite(op, sizeof(t_op), nb_op, F);

    fclose(F);
    modif = 0;
    affiche_touches();
    _gotoxy(x_champ[pos_champ], POS_LIGNE);
    return 1;
}

// ----------------------------------------------------------------------------

void son_erreur()
{
    #ifdef MSDOS
        sound(250); delay(35); nosound();
        delay(30);
        sound(250); delay(35); nosound();
    #else
        print("\007");
    #endif
}

void affiche_barres()
{
    int     i;

    setcolor(LIGHTGRAY, BLACK);
    for (i = 3; i < 25; i++)
    {
        // print_xy(13, i, "");
        print_xy(17, i, "");
        print_xy(45, i, "");
        print_xy(57, i, "");
        // print_xy(69, i, "");
    }
}

void affiche_libelles()
{
    if (type_solde == SOLDE_REEL)
        print_xy_c(1, 2, BLUE, CYAN, "    Date     P           Libell             Debit      Crdit    Solde R  ");
    else
        print_xy_c(1, 2, BLUE, CYAN, "    Date     P           Libell             Debit      Crdit   Solde BNQ ");
}

void init_ecran()
{
    int     i;

    setcolor(LIGHTGRAY, BLACK);
    clearscreen();
    print_xy_c(1, 1, LIGHTGRAY, BLUE,
        "                                                                                ");
    print_xy(2, 1, "Solde rel:             Solde banque:");
    print_xy(54, 1, " non point(s): ");
    //print_xy_c(1, 2, BLUE, CYAN,   "    Date     P           Libell             Debit      Crdit  ");
    //affiche_libelle_solde();
    affiche_libelles();
    affiche_touches();
    affiche_barres();
}

// ----------------------------------------------------------------------------

void decaler_undos()
{
    memcpy(&undo[0], &undo[1], sizeof(t_undo)*(NB_MAX_UNDO-1));
    nb_undo--;
    nb_max_undo_depasse = 1;
}

void affiche_champ(int no_op, int no_champ, int ligne)
{
    unsigned char   coul;

    coul = op[no_op].couleur;
    if ((no_champ == 4) && ((no_op >= nb_op-1) || (op[no_op].mois != op[no_op+1].mois)))
    {
        if (no_op == pos_op)
            setcolor(c_solde_fin_mois[coul], c_op_active_f[coul]);
        else
            setcolor(c_solde_fin_mois[coul], BLACK);
    }
    else
        if (no_champ == 4)
        {
            switch (type_solde)
            {
                case SOLDE_BANQUE:
                    if (no_op == pos_op)
                        setcolor(c_solde_bnq_actif[coul], c_op_active_f[coul]);
                    else
                        setcolor(c_solde_bnq[coul], c_champ_normal_f[coul]);
                    break;
                case SOLDE_REEL:
                    if (no_op == pos_op)
                        setcolor(c_solde_reel_actif[coul], c_op_active_f[coul]);
                    else
                        setcolor(c_solde_reel[coul], c_champ_normal_f[coul]);
                    break;
            }
        }
        else
            if (no_op == pos_op)
            {
                if (no_champ == pos_champ)
                    setcolor(c_champ_actif[coul], c_champ_actif_f[coul]);
                else
                    setcolor(c_op_active[coul], c_op_active_f[coul]);
            }
            else
                setcolor(c_champ_normal[coul], c_champ_normal_f[coul]);
    if (no_op > nb_op-1)
        switch (no_champ)
        {
            case  0:
                print_xy(x_champ[no_champ], ligne, "            ");
                setcolor(LIGHTGRAY, BLACK);
                print_xy(x_champ[no_champ]+12, ligne, "");
                break;
            case  1:
                print_xy(x_champ[no_champ], ligne, "   ");
                break;
            case  2:
                print_xy(x_champ[no_champ], ligne,
                    "                           ");
                break;
            case  3:
                print_xy(x_champ[no_champ], ligne, "           ");
                print_xy(x_champ[3]+12, ligne, "           ");
                break;
            case  4:
                print_xy(x_champ[no_champ], ligne, "           ");
                x_curseur = 80;
                y_curseur--;
                print_xy_c(x_champ[no_champ]-1, ligne, LIGHTGRAY, BLACK, "");
                break;
        }
    else
        switch (no_champ)
        {
            case  0:
                print_xy(x_champ[no_champ], ligne,
                    " %02d/%02d/%04d ", op[no_op].jour,
                    op[no_op].mois, op[no_op].annee);
                if ( (no_op == 0) || (op[no_op].mois != op[no_op-1].mois) )
                    print_xy_c(x_champ[no_champ]+12, ligne, LIGHTGRAY, BLACK, "");
                else
                    print_xy_c(x_champ[no_champ]+12, ligne, LIGHTGRAY, BLACK, "");
                break;
            case  1:
                if (op[no_op].pointe)
                    print_xy(x_champ[no_champ], ligne, " x ");
                else
                    print_xy(x_champ[no_champ], ligne, "   ");
                break;
            case  2:
                print_xy(x_champ[no_champ], ligne, " %-26s",
                    op[no_op].libelle);
                break;
            case  3:
                if (op[no_op].montant < 0)
                {
                    if (euro)
                        print_xy(x_champ[no_champ], ligne, "%10.2f ",
                            -op[no_op].montant/taux_euro);
                    else
                        print_xy(x_champ[no_champ], ligne, "%10.2f ",
                            -op[no_op].montant);
                }
                else
                    print_xy(x_champ[no_champ], ligne, "           ");
                if (op[no_op].montant > 0)
                {
                    if (euro)
                        print_xy(x_champ[no_champ]+12, ligne, "%10.2f ",
                            op[no_op].montant/taux_euro);
                    else
                        print_xy(x_champ[no_champ]+12, ligne, "%10.2f ",
                            op[no_op].montant);
                }
                else
                    print_xy(x_champ[no_champ]+12, ligne, "           ");
                break;
            case  4:
                if (euro)
                    print_xy(x_champ[no_champ], ligne, "%10.2f ",
                        solde_apres[no_op]/taux_euro);
                else
                    print_xy(x_champ[no_champ], ligne, "%10.2f ",
                        solde_apres[no_op]);
                x_curseur = 80;
                y_curseur--;
                if ( (no_op == 0) || (op[no_op].mois != op[no_op-1].mois) )
                    print_xy_c(x_champ[no_champ]-1, ligne, LIGHTGRAY, BLACK, "");
                else
                    print_xy_c(x_champ[no_champ]-1, ligne, LIGHTGRAY, BLACK, "");
                break;
        }
    if ( (no_op == pos_op) && (no_champ == pos_champ) )
        _gotoxy(x_champ[pos_champ], POS_LIGNE);
}

void affiche_op(int no_op)
{
    int     ligne, i;

    ligne = 3+(no_op-op_debut);

    for (i = 0; i < 5; i++)
        affiche_champ(no_op, i, ligne);

    if (no_op == pos_op) _gotoxy(x_champ[pos_champ], ligne);
}

void affiche_op_b(int no_op)
// affiche une operation et dessine les barres verticales grises
{
    int     ligne;

    ligne = 3+(no_op-op_debut);
    affiche_op(no_op);
    setcolor(LIGHTGRAY, BLACK);
    print_xy(x_champ[2]-1, ligne, "");
    print_xy(x_champ[3]-1, ligne, "");
    print_xy(x_champ[3]+11, ligne, "");
}

void affiche_ecran()
{
    int     i, j, ligne;

    ligne = 3;
    for (i = op_debut; i < op_debut+22; i++)
    {
        for (j = 0; j < 5; j++)
            affiche_champ(i, j, ligne);
        ligne++;
    }
    _gotoxy(x_champ[pos_champ], POS_LIGNE);
}

void efface_barre_selection()
{
    int     i, old_pos_op;

    old_pos_op = pos_op;
    pos_op = -1;
    for (i = 0; i < 5; i++)
        affiche_champ(old_pos_op, i, 3+(old_pos_op-op_debut));
    pos_op = old_pos_op;
}

// ----------------------------------------------------------------------------

void calculs()
// calcul du solde du compte, du nombre de non pointes et de la somme des non
// pointes et affiche les resultats trouves dans la barre 'statut' en haut
{
    int     i;

    solde_reel = 0;
    nb_non_pointes = 0;
    somme_non_pointes = 0;
    solde_banque = 0;
    for (i = 0; i < nb_op; i++)
    {
        solde_reel += op[i].montant;
        //op[i].solde_apres = solde_reel;
        if (op[i].pointe)
            solde_banque += op[i].montant;
        if (type_solde == SOLDE_REEL)
            solde_apres[i] = solde_reel;
        else
            solde_apres[i] = solde_banque;
        if (!op[i].pointe)
        {
            nb_non_pointes++;
            somme_non_pointes += op[i].montant;
        }
    }
    affiche_statut(1);
    affiche_pos();
}

// ----------------------------------------------------------------------------

unsigned char   *texte[] =
    {
    "DEPLACEMENT",
    "",
    "      Flches : dplacement de la barre de slection",
    "         Home : retour au dbut (la 1re opration affiche)",
    "          End : saisie d'une nouvelle opration",
    "         PgUp : monte d'une page",
    "         PgDn : descend d'une page",
    "    Ctrl+Haut : saute au groupe de points/non points prcdent",
    "     Ctrl+Bas : saute au groupe de points/non points suivant",
    "     Alt+Haut : avance l'opration dans la mme journe",
    "      Alt+Bas : recule l'opration dans la mme journe",
    "            D : affiche les op. a partir de l'op. courante",
    "                (cela permet de voir une partie seulement des oprations)",
    "       Ctrl+D : affiche toutes les op. (annule l'effet de la touche 'D')",
    "",
    "SAISIE/MODIFICATIONS",
    "",
    "          Entre : (*) dite le champ slectionn",
    "     Ctrl+Entre : (*) recopie le champ de l'opration prcdente",
    "                       (sauf le montant)",
    "           Suppr : (*) efface le champ slectionn (sauf la date)",
    "      Ctrl+Suppr : (*) efface l'opration slectionne",
    "             -,+ : (*) (sur une date) passe au jour prcdent/suivant",
    "               P : pointe (et verrouille) l'opration slectionne",
    "                   (une opration pointe ne peut plus tre modifie)",
    "               A : annule le pointage",
    "           Alt+B : affiche les soldes intermdiaires rels ou banque",
    "                   sachant que le solde banque ne tient pas compte des",
    "                   oprations non pointes",
    "           Alt+E : bascule Francs / Euros (1 Euro = 6,50 Francs)",
    "    Alt+BckSpace : annuler la dernire opration",
    "          Ctrl+U : surligne les dernires modifications de l'cran affich",
    "           Alt+U : affiche la liste des dernires modifications",
    "                   (dans cette liste, le dplacement est possible avec les",
    "                   flches, Home, End, PgUp et PgDn)",
    "",
    "    (*) l'opration ne doit pas tre pointe",
    "",
    "RECHERCHE",
    "",
    "    F5 : ouvre la boite de dialogue de recherche globale",
    "         La recherche globale s'effectue sur toutes les oprations, mme si",
    "         toutes les oprations ne sont pas affiches.",
    "    F6 : ouvre la boite de dialogue de recherche locale",
    "         La recherche locale s'effectue seulement sur les oprations affiches.",
    "",
    "    Touches utilises dans ces boites de dialogue:",
    "",
    "        Flches : dplacement de la barre de slection",
    "         Entre : diter le libell ou le montant",
    "                  valider la recherche si bouton \"Rechercher\" slectionn",
    "         Espace : cocher/dcocher un champ",
    "            -,+ : modifier une date",
    "         Ctrl+R : rinitialiser tous les critres de recherche",
    "          Echap : annuler la recherche",
    "",
    "    Touches utilises lors de la consultation des oprations trouves:",
    "",
    "         Haut, Bas : dplacement d'une ligne",
    "        PgUp, PgDn : dplacement d'un cran",
    "                 M : marquer les oprations et retourner au mode normal",
    "             Echap : retourner au mode normal",
    "",
    "",
    COPYRIGHT,
    NULL };

int     l_pos;

// AD_affiche: affiche les lignes de l'aide dtaille (AD)

void AD_affiche()
{
    int     i, j;

    j = 4;
    setcolor(BLACK, CYAN);
    for (i = l_pos; i < l_pos+19; i++)
    {
        _gotoxy(2, j++);
        //clrtoeol();
        print("%s", texte[i]);
        clrtoeol();
    }
//    _gotoxy(35, 24);
}

void affiche_aide_detaillee()
{
    int     i, j, k;

    setcolor(BLACK, CYAN);
    clearscreen();
    print_xy(2,  2, "  AIDE DETAILLEE  ");
    print_xy_c(35, 24, YELLOW, BLUE,  "    O");
    setcolor(WHITE, BLUE);
    print("K    ");
    print_xy_c(45, 24, BLACK, CYAN, "");
    print_xy(36, 25, "");
    l_pos = 0;
    AD_affiche();
    while (1)
    {
        setcolor(BLUE, CYAN);
        if (l_pos > 0)
        {
            print_xy(2, 24, " /\\ ");
            print_xy(2, 25, "    ");
        }
        else
        {
            print_xy(2, 24, "     ");
            print_xy(2, 25, "     ");
        }
        if (texte[l_pos+19] != NULL)
        {
            print_xy(75, 24, "    ");
            print_xy(75, 25, " \\/ ");
        }
        else
        {
            print_xy(75, 24, "     ");
            print_xy(75, 25, "     ");
        }
        _gotoxy(35, 24);
        k = mon_getch();
        switch (k)
        {
            case K_ECHAP:
            case K_RETURN:
                return;
            case K_HAUT:
                if (l_pos > 0)
                {
                    l_pos--;
                    AD_affiche();
                }
                break;
            case K_BAS:
                if (texte[l_pos+19] != NULL)
                {
                    l_pos++;
                    AD_affiche();
                }
                break;
            case K_HOME:
                l_pos = 0;
                AD_affiche();
                break;
            case K_END:
                if (texte[l_pos+19] != NULL)
                {
                    do l_pos++; while (texte[l_pos+19] != NULL);
                    AD_affiche();
                }
                break;
            case K_PGUP:
                if (l_pos > 0)
                {
                    if (l_pos <= 19)
                        l_pos = 0;
                    else
                        l_pos -= 19;
                    AD_affiche();
                }
                break;
            case K_PGDN:
                if (texte[l_pos+19] != NULL)
                {
                    i = 0;
                    while ( (texte[l_pos+19] != NULL) && (i < 19) )
                    {
                        l_pos++;
                        i++;
                    }
                    AD_affiche();
                }
                break;
        }
    }
}

void affiche_aide()
{
    int     i, k, b_pos;

    //efface_barre_selection();
    setcolor(BLACK, CYAN);
    clearscreen();
    print_xy(2,  2, "  AIDE  ");
    #ifdef MSDOS
        print_xy(3, 4, "      \x18,\x19,\x1b,\x1a : dplace la barre de slection");
        print_xy(3, 5, "     Ctrl+\x18,\x19 : saute au groupe de points/non points suivant");
        print_xy(3, 6, "      Alt+\x18,\x19 : dplace l'opration (dans la mme journe)");
    #else
        print_xy(3, 4, "      Flches : dplace la barre de slection");
        print_xy(3, 5, "Ctrl+Haut/Bas : saute au groupe de points/non points suivant");
        print_xy(3, 6, " Alt+Haut/Bas : dplace l'opration (dans le mme jour)");
    #endif
    print_xy(3,  7, "       Entre : dite le champ slectionn (si opration non pointe)");
    print_xy(3,  8, "  Ctrl+Entre : recopie le champ prcdent (sauf montant)");
    print_xy(3,  9, "        Suppr : efface le champ slectionn (sauf date ou op. pointe)");
    print_xy(3, 10, "   Ctrl+Suppr : efface l'opration slectionne (si op. non pointe)");
    print_xy(3, 11, "          -,+ : (sur une date) passe au jour prcdent/suivant");
    print_xy(3, 12, "            P : pointe (et verrouille) l'op. slectionne (A: dpointe l'op.)");
    print_xy(3, 13, "        Alt+B : bascule soldes intermdiaires Rels / Banque");
    print_xy(3, 14, "        Alt+E : bascule Francs / Euros (1 Euro = 6,50 Francs)");
    print_xy(3, 15, " Alt+BckSpace : annule la dernire modification");
    print_xy(3, 16, "       Ctrl+U : surligne les dernires modifications de l'cran affich");
    print_xy(3, 17, "        Alt+U : affiche la liste des dernires modifications");
    print_xy(3, 18, "           F5 : recherche des oprations selon des critres");
    print_xy(3, 19, "            D : affiche les op.  partir de la courante (Ctrl+D: tout voir)");
    print_xy(3, 20, "       Espace : marque/dmarque une opration");
    print_xy(3, 21, "      Alt+\"+\" : marque toutes les op. (Alt+\"-\": dmarque toutes les op.)");
    print_xy(3, 22, "        Alt+M : inverse les marquages");
    print_xy_c(13, 24, YELLOW, RED,  "          O");
    setcolor(WHITE, RED);
    print("K          ");
    print_xy_c(35, 24, BLACK, CYAN, "");
    print_xy(14, 25, "");
    print_xy_c(45, 24, YELLOW, BLUE, "  F1");
    setcolor(WHITE, BLUE);
    print("  Aide dtaille  ");
    print_xy_c(67, 24, BLACK, CYAN, "");
    print_xy(46, 25, "");
    /*setcolor(CYAN, BLACK);
    for (i = 5; i < 23; i++) print_xy(76, i, "");
    print_xy(5, 23, ""); */
    _gotoxy(13, 24);
    b_pos = 0;
    while (1)
    {
        k = mon_getch();
        switch (k)
        {
            case K_RETURN:          // ATTENTION: GROSSE BIDOUILLE !!!!!--
                if (b_pos == 1)
            case K_F1:
                    affiche_aide_detaillee();
            case K_ECHAP:
            case 'o':
            case 'O':
                setcolor(LIGHTGRAY, BLACK);
                clearscreen();
                init_ecran();
                affiche_statut(1);
                affiche_ecran();
                _gotoxy(x_champ[pos_champ], POS_LIGNE);
                return;
            case K_GAUCHE:
                if (b_pos > 0)
                {
                    b_pos = 0;
                    print_xy_c(13, 24, YELLOW, RED,  "          O");
                    setcolor(WHITE, RED);
                    print("K          ");
                    print_xy_c(45, 24, YELLOW, BLUE, "  F1");
                    setcolor(WHITE, BLUE);
                    print("  Aide dtaille  ");
                    _gotoxy(13, 24);
                }
                break;
            case K_DROITE:
                if (b_pos == 0)
                {
                    b_pos = 1;
                    print_xy_c(13, 24, YELLOW, BLUE,  "          O");
                    setcolor(WHITE, BLUE);
                    print("K          ");
                    print_xy_c(45, 24, YELLOW, RED, "  F1");
                    setcolor(WHITE, RED);
                    print("  Aide dtaille  ");
                    _gotoxy(45, 24);
                }
                break;
        }
    }
}

// ----------------------------------------------------------------------------

void debut_affichage_op(int no_op)
{
    int     i;

    if (pos_op == 0) return;
    for (i = 0; i < no_op; i++)
        if (!op[i].pointe)
        {
            son_erreur();
            return;
        }
    for (i = 0; i < no_op; i++)
        op[i].couleur = 0;
    print_xy_c(4, 2, BLUE, CYAN, "!");
    print_xy_c(9, 2, BLUE, CYAN, "!");
    deb_op_aff = no_op;
    op_debut = no_op;
    affiche_ecran();
}

void restaurer_deb_op_aff()
{
    print_xy_c(4, 2, BLUE, CYAN, " ");
    print_xy_c(9, 2, BLUE, CYAN, " ");
    deb_op_aff = 0;
    op_debut = 0;
    pos_op = 0;
    affiche_ecran();
}

void calcul_op_debut()
{
/*    if (nb_op > 21) op_debut = pos_op;
    if (op_debut+21 > nb_op) op_debut = nb_op-21;
    if (op_debut < 0) op_debut = 0; */

    if (nb_op-deb_op_aff > 21) op_debut = pos_op;
    if (op_debut+21 > nb_op) op_debut = nb_op-21;
    if (op_debut < deb_op_aff) op_debut = deb_op_aff;
}

// ----------------------------------------------------------------------------

int edite_chaine(int x, int y, int long_champ, int long_max,
                    int coul, int fond,
                    unsigned char *valeur_ini, unsigned char *result)
{
    unsigned char   chaine[50];
    int             k;
    int             i, xx, yy;

    for (i = 0; i < long_champ; i++) chaine[i] = ' ';
    chaine[long_champ] = '\0';
    yy = y_curseur;
    print_xy_c(x, y, coul, fond, "%s", chaine);
    strcpy(chaine, valeur_ini);
    print_xy_c(x, y, coul, fond, "%s", chaine);
    xx = strlen(chaine);
    while (1)
    {
        _gotoxy(x+xx, yy);
        k = mon_getch();
        if ((k >= ' ') && (k <= '}') && (strlen(chaine) < long_max))
        {
            i = strlen(chaine);
            chaine[i+1] = '\0';
            while (i > xx) { chaine[i] = chaine[i-1]; i--; }
            chaine[xx++] = k;
            print_xy(x, y, "%s", chaine);
        }
        else
            switch (k)
            {
                case K_ECHAP:
                    strcpy(result, valeur_ini);
                    return 0;
                case K_RETURN:
                    strcpy(result, chaine);
                    return 1;
                case K_SUPPR:
                    if (xx < strlen(chaine))
                    {
                        i = xx;
                        while ((chaine[i] = chaine[i+1]) != '\0') i++;
                        print_xy(x, y, "%s ", chaine);
                    }
                    break;
                case K_BACKSPACE:
                    if (xx > 0)
                    {
                        i = xx-1;
                        while ((chaine[i] = chaine[i+1]) != '\0') i++;
                        xx--;
                        print_xy(x, y, "%s ", chaine);
                    }
                    break;
                case K_GAUCHE:
                    if (xx > 0) xx--;
                    break;
                case K_DROITE:
                    if (xx < strlen(chaine)) xx++;
                    break;
                case K_HOME:
                    xx = 0;
                    break;
                case K_END:
                    xx = strlen(chaine);
                    break;
            }
    }
}

int quantieme_pos(int pos)
{
    int     i, res;

    if (op[pos].annee%4 == 0)
        nb_jours[1] = 29;
    else
        nb_jours[1] = 28;
    res = (op[pos].annee-1901)*365+(op[pos].annee-1901)/4;
    for (i = 0; i < op[pos].mois-1; i++) res += nb_jours[i];
    res += op[pos].jour;
    return res;
}

int quantieme(int jj, int mm, int aaaa)
{
    int     i, res;

    if (aaaa%4 == 0)
        nb_jours[1] = 29;
    else
        nb_jours[1] = 28;
    res = (aaaa-1901)*365+(aaaa-1901)/4;
    for (i = 0; i < mm-1; i++) res += nb_jours[i];
    res += jj;
    return res;
}

void deplace_date()
{
// deplace l'operation (si besoin) en fonction de sa date (pour garder les
// operations triees par date)
    t_op    op_temp;

    if ( (pos_op+1 < nb_op) && (quantieme_pos(pos_op) > quantieme_pos(pos_op+1)) )
    {
        do
        {
            memcpy(&op_temp, &op[pos_op], sizeof(t_op));
            memcpy(&op[pos_op], &op[pos_op+1], sizeof(t_op));
            memcpy(&op[pos_op+1], &op_temp, sizeof(t_op));
            pos_op++;
        } while ( (pos_op+1 < nb_op) && (quantieme_pos(pos_op) > quantieme_pos(pos_op+1)) );
        calculs();
        calcul_op_debut();
        /*if (op_debut == 0)
            restaurer_deb_op_aff();
        else
            if (op_debut < deb_op_aff)
                deb_op_aff = op_debut;*/
        affiche_ecran();
        return;
    }
    if ( (pos_op > 0) && (quantieme_pos(pos_op) < quantieme_pos(pos_op-1)) )
    {
        do
        {
            memcpy(&op_temp, &op[pos_op], sizeof(t_op));
            memcpy(&op[pos_op], &op[pos_op-1], sizeof(t_op));
            memcpy(&op[pos_op-1], &op_temp, sizeof(t_op));
            pos_op--;
        } while ( (pos_op > 0) && (quantieme_pos(pos_op) < quantieme_pos(pos_op-1)) );
        calculs();
        calcul_op_debut();
        /*if (op_debut == 0)
            restaurer_deb_op_aff();
        else
            if (op_debut < deb_op_aff)
                deb_op_aff = op_debut;*/
        affiche_ecran();
        return;
    }
}

void affiche_date_edition(unsigned char pos_date)
{
    unsigned char   coul;

    coul = op[pos_op].couleur;
    switch (pos_date)
    {
        case 0:
            print_xy_c(x_champ[0], y_curseur, c_edition, c_edition_f, " ");
            print_xy_c(x_champ[0]+1, y_curseur, c_champ_actif[coul],
                c_champ_actif_f[coul], "%02d", op[pos_op].jour);
            print_xy_c(x_champ[0]+3, y_curseur, c_edition, c_edition_f,
                "/%02d/%04d ", op[pos_op].mois, op[pos_op].annee);
            _gotoxy(x_champ[0]+1, y_curseur);
            break;
        case 1:
            print_xy_c(x_champ[0], y_curseur, c_edition, c_edition_f,
                " %02d/", op[pos_op].jour);
            print_xy_c(x_champ[0]+4, y_curseur, c_champ_actif[coul],
                c_champ_actif_f[coul], "%02d", op[pos_op].mois);
            print_xy_c(x_champ[0]+6, y_curseur, c_edition, c_edition_f,
                "/%04d ", op[pos_op].annee);
            _gotoxy(x_champ[0]+4, y_curseur);
            break;
        case 2:
            print_xy_c(x_champ[0], y_curseur, c_edition, c_edition_f,
                " %02d/%02d/", op[pos_op].jour, op[pos_op].mois);
            print_xy_c(x_champ[0]+7, y_curseur, c_champ_actif[coul],
                c_champ_actif_f[coul], "%04d", op[pos_op].annee);
            print_xy_c(x_champ[0]+11, y_curseur, c_edition, c_edition_f, " ");
            _gotoxy(x_champ[0]+7, y_curseur);
            break;
    }
}

void edite_date()
{
    int             k;
    unsigned char   old_pos_op, pos_date, op_creee, date_modifiee;
    int             jj, mm, aaaa;

    jj = op[pos_op].jour;
    mm = op[pos_op].mois;
    aaaa = op[pos_op].annee;
    affiche_date_edition(0);
    pos_date = 0;
    while (1)
    {
        k = mon_getch();
        switch (k)
        {
            case K_GAUCHE:
                if (pos_date > 0) affiche_date_edition(--pos_date);
                break;
            case K_DROITE:
                if (pos_date < 2) affiche_date_edition(++pos_date);
                break;
            case K_ECHAP:
                op[pos_op].jour = jj;
                op[pos_op].mois = mm;
                op[pos_op].annee = aaaa;
                affiche_champ(pos_op, pos_champ, POS_LIGNE);
                return;
            case K_RETURN:
                op_creee = (pos_op == nb_op);
                if (op_creee)
                {
                    modif = 1;
                    nb_op++;
                    op[pos_op].pointe = 0;
                    op[pos_op].libelle[0] = '\0';
                    op[pos_op].montant = 0;
                    solde_apres[pos_op] = solde_apres[pos_op-1];
                    if (POS_LIGNE != 3)
                        affiche_champ(pos_op-1, 4, POS_LIGNE-1);
                    affiche_champ(pos_op, 4, POS_LIGNE);
                    calculs();
                }
                affiche_champ(pos_op, pos_champ, POS_LIGNE);
                old_pos_op = pos_op;
                deplace_date();

                date_modifiee = (jj != op[pos_op].jour)
                    || (mm != op[pos_op].mois)
                    || (aaaa != op[pos_op].annee);
                if (date_modifiee) modif = 1;

                if ( (op_creee)
                    || ( (date_modifiee)
                    && ( (op_creee) || (nb_undo == 0)
                        || (undo[nb_undo-1].u_code != U_RESTAURER_DATE)
                        || (undo[nb_undo-1].u_no_op != pos_op)
                        || (jj != op[pos_op].jour)
                        || (mm != op[pos_op].mois)
                        || (aaaa != op[pos_op].annee) ) ) )
                {
                    if (nb_undo == NB_MAX_UNDO) decaler_undos();
                    undo[nb_undo].u_code = U_RESTAURER_DATE;
                    undo[nb_undo].u_no_op = pos_op;
                    undo[nb_undo].u_old_no_op = old_pos_op;
                    undo[nb_undo].u_op_creee = op_creee;
                    undo[nb_undo].u_op.jour = jj;
                    undo[nb_undo].u_op.mois = mm;
                    undo[nb_undo].u_op.annee = aaaa;
                    nb_undo++;
                }

                affiche_pos();
                return;
            case '+':
                switch (pos_date)
                {
                    case 0:
                        if (op[pos_op].annee%4 == 0)
                            nb_jours[1] = 29;
                        else
                            nb_jours[1] = 28;
                        if (op[pos_op].jour < nb_jours[op[pos_op].mois-1])
                        {
                            op[pos_op].jour++;
                            affiche_date_edition(pos_date);
                        }
                        break;
                    case 1:
                        if (op[pos_op].mois < 12)
                        {
                            op[pos_op].mois++;
                            affiche_date_edition(pos_date);
                        }
                        break;
                    case 2:
                        if (op[pos_op].annee < 2099)
                        {
                            op[pos_op].annee++;
                            affiche_date_edition(pos_date);
                        }
                        break;
                }
                break;
            case '-':
                switch (pos_date)
                {
                    case 0:
                        if (op[pos_op].jour > 1)
                            if ( (deb_op_aff > 0)
                                && (quantieme(op[pos_op].jour-1,
                                op[pos_op].mois, op[pos_op].annee) <
                                quantieme(op[deb_op_aff].jour,
                                op[deb_op_aff].mois,
                                op[deb_op_aff].annee)) )
                                son_erreur();
                            else
                            {
                                op[pos_op].jour--;
                                affiche_date_edition(pos_date);
                            }
                        break;
                    case 1:
                        if (op[pos_op].mois > 1)
                            if ( (deb_op_aff > 0)
                                && (quantieme(op[pos_op].jour,
                                op[pos_op].mois-1, op[pos_op].annee) <
                                quantieme(op[deb_op_aff].jour,
                                op[deb_op_aff].mois,
                                op[deb_op_aff].annee)) )
                                son_erreur();
                            else
                            {
                                op[pos_op].mois--;
                                affiche_date_edition(pos_date);
                            }
                        break;
                    case 2:
                        if (op[pos_op].annee > 1980)
                            if ( (deb_op_aff > 0)
                                && (quantieme(op[pos_op].jour,
                                op[pos_op].mois, op[pos_op].annee-1) <
                                quantieme(op[deb_op_aff].jour,
                                op[deb_op_aff].mois,
                                op[deb_op_aff].annee)) )
                                son_erreur();
                            else
                            {
                                op[pos_op].annee--;
                                affiche_date_edition(pos_date);
                            }
                        break;
                }
                break;
        }
    }
}

int edite_libelle()
{
    unsigned char   chaine[27], ancien_libelle[27];
    int             edit_ok;

    strcpy(ancien_libelle, op[pos_op].libelle);
    edit_ok = edite_chaine(x_champ[2], POS_LIGNE, 27, 26, c_edition,
                c_edition_f, op[pos_op].libelle, op[pos_op].libelle);
    if ( (edit_ok) &&
        ( (strcmp(ancien_libelle, op[pos_op].libelle) != 0)
        || (pos_op == nb_op) ) )
    {
        if (nb_undo == NB_MAX_UNDO) decaler_undos();
        undo[nb_undo].u_code = U_MODIFIER_LIBELLE;
        undo[nb_undo].u_no_op = pos_op;
        undo[nb_undo].u_op_creee = (pos_op == nb_op);
        strcpy(undo[nb_undo].u_op.libelle, ancien_libelle);
        nb_undo++;
    }
    if ( (edit_ok) && (pos_op == nb_op) )
    {
        lit_date_systeme();
        op[pos_op].jour = jour_systeme;
        op[pos_op].mois = mois_systeme;
        op[pos_op].annee = annee_systeme;
        op[pos_op].montant = 0;
        solde_apres[pos_op] = solde_apres[pos_op-1];
        nb_op++;
        modif = 1;
        affiche_champ(pos_op, 0, POS_LIGNE);
        if (POS_LIGNE != 3)
            affiche_champ(pos_op-1, 4, POS_LIGNE-1);
        affiche_champ(pos_op, 4, POS_LIGNE);
        nb_non_pointes++;
        affiche_statut(1);
        affiche_pos();
    }
    if (strcmp(ancien_libelle, op[pos_op].libelle) != 0)
        modif = 1;
    affiche_champ(pos_op, pos_champ, POS_LIGNE);
    affiche_pos();
    return edit_ok;
}

void edite_montant()
{
    unsigned char   chaine[21], result[21];
    double          nouveau_montant;
    int             res;

    if (euro)
        montant_en_chaine(chaine, op[pos_op].montant/taux_euro);
    else
        montant_en_chaine(chaine, op[pos_op].montant);
    if (strcmp(chaine, "0") == 0)
        chaine[0] = '\0';
    res = edite_chaine(x_champ[3], y_curseur, 23, 11, c_edition, c_edition_f,
        chaine, result);
    nouveau_montant = 0;
    nouveau_montant = atof(result);
    if (euro) nouveau_montant = nouveau_montant*taux_euro;
    if ( (nouveau_montant >= -9999999.99) && (nouveau_montant <= 9999999.99)
        && (nouveau_montant != op[pos_op].montant) && (res) )
    {
        if (nb_undo == NB_MAX_UNDO) decaler_undos();
        undo[nb_undo].u_code = U_MODIFIER_MONTANT;
        undo[nb_undo].u_no_op = pos_op;
        undo[nb_undo].u_op_creee = (pos_op == nb_op);
        undo[nb_undo].u_op.montant = op[pos_op].montant;
        nb_undo++;

        modif = 1;
        if (pos_op == nb_op)
        {
            lit_date_systeme();
            op[pos_op].jour = jour_systeme;
            op[pos_op].mois = mois_systeme;
            op[pos_op].annee = annee_systeme;
            nb_op++;
        }
        op[pos_op].montant = nouveau_montant;
        print_xy_c(x_champ[3]+11, y_curseur, LIGHTGRAY, BLACK, "");
        calculs();
        affiche_ecran();
    }
    else
    {
        print_xy_c(x_champ[3]+11, y_curseur, LIGHTGRAY, BLACK, "");
        affiche_champ(pos_op, 3, POS_LIGNE);
        _gotoxy(x_champ[pos_champ], y_curseur);
    }
}

void efface_operation()
{
    if (pos_op > nb_op-1)
        return;

    if (nb_undo == NB_MAX_UNDO) decaler_undos();
    undo[nb_undo].u_code = U_RECREER_OP;
    undo[nb_undo].u_no_op = pos_op;
    // undo[nb_undo].u_op_creee =;
    undo[nb_undo].u_op.jour = op[pos_op].jour;
    undo[nb_undo].u_op.mois = op[pos_op].mois;
    undo[nb_undo].u_op.annee = op[pos_op].annee;
    undo[nb_undo].u_op.pointe = op[pos_op].pointe;
    strcpy(undo[nb_undo].u_op.libelle, op[pos_op].libelle);
    undo[nb_undo].u_op.montant = op[pos_op].montant;
    nb_undo++;

    if (pos_op == nb_op-1)
    {
        op[pos_op].pointe = 0;
        op[pos_op].libelle[0] = '\0';
        op[pos_op].montant = 0;
        nb_op--;
        pos_op--;
        if (POS_LIGNE < 3)
            calcul_op_debut();
    }
    else
        if (pos_op < nb_op-1)
        {
            memcpy(&op[pos_op], &op[pos_op+1], sizeof(t_op)*(nb_op-pos_op-1));
            nb_op--;
            op[nb_op].pointe = 0;
            op[nb_op].libelle[0] = '\0';
            op[nb_op].montant = 0;
        }
    modif = 1;
    calculs();
    affiche_ecran();
    _gotoxy(x_champ[pos_champ], POS_LIGNE);
}

void insere_operation()
{
    int     i;

    for (i = nb_op; i > pos_op; i--)
    {
        memcpy(&op[i], &op[i-1], sizeof(t_op));
        solde_apres[i] = solde_apres[i-1];
    }

    if (nb_undo == NB_MAX_UNDO) decaler_undos();
    undo[nb_undo].u_code = U_EFFACER_OP;
    undo[nb_undo].u_no_op = pos_op;
    nb_undo++;

    nb_op++;
    op[pos_op].couleur = 0;
    op[pos_op].jour = op[pos_op+1].jour;
    op[pos_op].mois = op[pos_op+1].mois;
    op[pos_op].annee = op[pos_op+1].annee;
    op[pos_op].pointe = 0;
    op[pos_op].libelle[0] = '\0';
    op[pos_op].montant = 0;
    solde_apres[pos_op] = solde_apres[pos_op-1];
    affiche_ecran();
    modif = 1;
    affiche_pos();
}

void recopie_champ()
{
    switch (pos_champ)
    {
        case 0:
            if (pos_op == nb_op)
            {
                modif = 1;
                if (pos_op > 1)
                {
                    op[pos_op].jour = op[pos_op-1].jour;
                    op[pos_op].mois = op[pos_op-1].mois;
                    op[pos_op].annee = op[pos_op-1].annee;
                }
                else
                {
                    lit_date_systeme();
                    op[pos_op].jour = jour_systeme;
                    op[pos_op].mois = mois_systeme;
                    op[pos_op].annee = annee_systeme;
                }
                op[pos_op].libelle[0] = '\0';
                op[pos_op].montant = 0;
                nb_op++;
                if (POS_LIGNE != 3)
                    affiche_champ(pos_op-1, 4, POS_LIGNE-1);
                affiche_champ(pos_op, 0, POS_LIGNE);
            }
            else
                if ( (pos_op > 0) && (!op[pos_op].pointe) )
                {
                    modif = 1;
                    op[pos_op].jour = op[pos_op-1].jour;
                    op[pos_op].mois = op[pos_op-1].mois;
                    op[pos_op].annee = op[pos_op-1].annee;
                    if (POS_LIGNE != 24)
                    {
                        affiche_champ(pos_op+1, 0, POS_LIGNE+1);
                        affiche_champ(pos_op+1, 4, POS_LIGNE+1);
                    }
                    if (POS_LIGNE != 3)
                        affiche_champ(pos_op-1, 4, POS_LIGNE-1);
                    affiche_champ(pos_op, 0, POS_LIGNE);
                }
            break;
        case 2:
            if (op[pos_op].pointe)
                son_erreur();
            else
                if (op[pos_op].libelle[0] == '\0')
                {
                    modif = 1;
                    strcpy(op[pos_op].libelle, op[pos_op-1].libelle);
                    if (pos_op == nb_op)
                    {
                        lit_date_systeme();
                        op[pos_op].jour = jour_systeme;
                        op[pos_op].mois = mois_systeme;
                        op[pos_op].annee = annee_systeme;
                        op[pos_op].montant = 0;
                        nb_op++;
                        if (POS_LIGNE != 3)
                            affiche_champ(pos_op-1, 4, POS_LIGNE-1);
                        affiche_champ(pos_op, 0, POS_LIGNE);
                    }
                    affiche_champ(pos_op, 2, POS_LIGNE);
                }
            break;
/*        case  3:if (op[pos_op-1].montant != 0)
                {
                    op[pos_op].montant = op[pos_op-1].montant;
                    lit_date_systeme();
                    op[pos_op].jour = jour_systeme;
                    op[pos_op].mois = mois_systeme;
                    op[pos_op].annee = annee_systeme;
                    nb_op++;
                    affiche_champ(pos_op, 0, POS_LIGNE);
                    affiche_champ(pos_op, 3, POS_LIGNE);
                }
                break; */
    }
    calculs();
    affiche_champ(pos_op, 4, POS_LIGNE);
    _gotoxy(x_champ[pos_champ], POS_LIGNE);
}

void efface_champ()
{
    if ( (op[pos_op].pointe) && (pos_champ > 0) )
        { son_erreur(); return; }
    else
        if ( (pos_champ == 0) || (pos_op == nb_op) )
            return;
    switch (pos_champ)
    {
        case 2:
            if (op[pos_op].libelle[0] != '\0')
            {
                modif = 1;
                op[pos_op].libelle[0] = '\0';
                affiche_champ(pos_op, pos_champ, POS_LIGNE);
            }
            break;
        case 3:
            if (op[pos_op].montant != 0)
            {
                modif = 1;
                op[pos_op].montant = 0;
                calculs();
                affiche_ecran();
            }
            break;
    }
}

void jour_suivant()
{
    int     jj, mm, aaaa, old_pos_op;

    jj = op[pos_op].jour;
    mm = op[pos_op].mois;
    aaaa = op[pos_op].annee;

    if ( (aaaa == 2099) && (mm == 12) && (jj == 31) ) return;

    if (op[pos_op].annee%4 == 0)
        nb_jours[1] = 29;
    else
        nb_jours[1] = 28;
    op[pos_op].jour++;
    if (op[pos_op].jour > nb_jours[op[pos_op].mois-1])
    {
        op[pos_op].jour = 1;
        if (op[pos_op].mois == 12)
        {
            op[pos_op].mois = 1;
            op[pos_op].annee++;
        }
        else
            op[pos_op].mois++;
    }

    old_pos_op = pos_op;
    deplace_date();
    if (old_pos_op == pos_op) affiche_ecran();

    if ( (jj != op[pos_op].jour) || (mm != op[pos_op].mois)
        || (aaaa != op[pos_op].annee) )
        modif = 1;

    if ( (nb_undo == 0)
        || (undo[nb_undo-1].u_code != U_RESTAURER_DATE)
        || (undo[nb_undo-1].u_no_op != pos_op) )
    {
        if (nb_undo == NB_MAX_UNDO) decaler_undos();
        undo[nb_undo].u_code = U_RESTAURER_DATE;
        undo[nb_undo].u_no_op = pos_op;
        undo[nb_undo].u_old_no_op = old_pos_op;
        undo[nb_undo].u_op_creee = 0;
        undo[nb_undo].u_op.jour = jj;
        undo[nb_undo].u_op.mois = mm;
        undo[nb_undo].u_op.annee = aaaa;
        nb_undo++;
    }

    affiche_pos();
}

void jour_precedent()
{
    int     jj, mm, aaaa, old_pos_op;

    jj = op[pos_op].jour;
    mm = op[pos_op].mois;
    aaaa = op[pos_op].annee;

    if ( (aaaa == 1980) && (mm == 1) && (jj == 1) ) return;

    if ( (pos_op > 0) && (deb_op_aff > 0) )
    {
        if (quantieme_pos(pos_op)-quantieme_pos(deb_op_aff) == 0)
        {
            son_erreur();
            return;
        }
    }

    if (op[pos_op].annee%4 == 0)
        nb_jours[1] = 29;
    else
        nb_jours[1] = 28;
    op[pos_op].jour--;
    if (op[pos_op].jour == 0)
    {
        if (op[pos_op].mois == 1)
        {
            op[pos_op].mois = 12;
            op[pos_op].annee--;
        }
        else
            op[pos_op].mois--;
        op[pos_op].jour = nb_jours[op[pos_op].mois-1];
    }
    if (POS_LIGNE > 3) affiche_op(pos_op-1);
    affiche_op(pos_op);

    old_pos_op = pos_op;
    deplace_date();
    if (old_pos_op == pos_op) affiche_ecran();

    if ( (jj != op[pos_op].jour) || (mm != op[pos_op].mois)
        || (aaaa != op[pos_op].annee) )
        modif = 1;

    if ( (nb_undo == 0)
        || (undo[nb_undo-1].u_code != U_RESTAURER_DATE)
        || (undo[nb_undo-1].u_no_op != pos_op) )
    {
        if (nb_undo == NB_MAX_UNDO) decaler_undos();
        undo[nb_undo].u_code = U_RESTAURER_DATE;
        undo[nb_undo].u_no_op = pos_op;
        undo[nb_undo].u_old_no_op = old_pos_op;
        undo[nb_undo].u_op_creee = 0;
        undo[nb_undo].u_op.jour = jj;
        undo[nb_undo].u_op.mois = mm;
        undo[nb_undo].u_op.annee = aaaa;
        nb_undo++;
    }

    affiche_pos();
}

// ----------------------------------------------------------------------------

void carte_bleue()
{
    unsigned char   ancien_libelle[27];

    strcpy(ancien_libelle, op[pos_op].libelle);
    strcpy(op[pos_op].libelle, "CB: ");
    if (!edite_libelle())
        strcpy(op[pos_op].libelle, ancien_libelle);
    else
    {
        modif = 1;

    }
    if (POS_LIGNE != 3)
        affiche_champ(pos_op-1, 4, POS_LIGNE-1);
    affiche_champ(pos_op, 2, POS_LIGNE);
    _gotoxy(x_champ[pos_champ], POS_LIGNE);
}

void cheque_suivant()
{
    unsigned char   chaine[27], car;
    int             i, numero_cheque;
    #ifndef MSDOS
    int             j;
    #endif

    modif = 1;
    for (i = pos_op-1; i >= 0; i--)
    {
        strcpy(chaine, op[i].libelle);
        if (strlen(chaine) > 7)
        {
            #ifdef MSDOS
                strupr(chaine);
            #else
                for (j = strlen(chaine)-1; j >= 0; j--)
                    if ( (chaine[j] >= 'a') && (chaine[j] <= 'z') )
                        chaine[j] -= ('a'-'A');
                    else
                        if (chaine[j] == 138) chaine[j] = 'E';
            #endif
            car = chaine[7];
            chaine[7] = '\0';
            if (strcmp(chaine, "CHEQUE ") == 0)
            {
                chaine[7] = car;
                strcpy(op[pos_op].libelle, "Cheque ");
                numero_cheque = atoi(&chaine[7])+1;
                sprintf(&(op[pos_op].libelle[7]), "%d", numero_cheque);
                if (nb_undo == NB_MAX_UNDO) decaler_undos();
                undo[nb_undo].u_code = U_MODIFIER_LIBELLE;
                undo[nb_undo].u_no_op = pos_op;
                undo[nb_undo].u_op_creee = (pos_op == nb_op);
                undo[nb_undo].u_op.libelle[0] = '\0';
                nb_undo++;
                if (pos_op == nb_op)
                {
                    lit_date_systeme();
                    op[pos_op].jour = jour_systeme;
                    op[pos_op].mois = mois_systeme;
                    op[pos_op].annee = annee_systeme;
                    op[pos_op].pointe = 0;
                    op[pos_op].montant = 0;
                    nb_op++;
                    calculs();
                    affiche_champ(pos_op, 0, POS_LIGNE);
                    if (POS_LIGNE != 3)
                        affiche_champ(pos_op-1, 4, POS_LIGNE-1);
                    affiche_champ(pos_op, 4, POS_LIGNE);
                }
                affiche_champ(pos_op, 2, POS_LIGNE);
                _gotoxy(x_champ[pos_champ], POS_LIGNE);
                return;
            }
        }
    }
    strcpy(op[pos_op].libelle, "Cheque 1");
    if (nb_undo == NB_MAX_UNDO) decaler_undos();
    undo[nb_undo].u_code = U_MODIFIER_LIBELLE;
    undo[nb_undo].u_no_op = pos_op;
    undo[nb_undo].u_op_creee = (pos_op == nb_op);
    undo[nb_undo].u_op.libelle[0] = '\0';
    nb_undo++;
    if (pos_op == nb_op)
    {
        lit_date_systeme();
        op[pos_op].jour = jour_systeme;
        op[pos_op].mois = mois_systeme;
        op[pos_op].annee = annee_systeme;
        op[pos_op].pointe = 0;
        op[pos_op].montant = 0;
        nb_op++;
        calculs();
        affiche_champ(pos_op, 0, POS_LIGNE);
        if (POS_LIGNE != 3)
            affiche_champ(pos_op-1, 4, POS_LIGNE-1);
        affiche_champ(pos_op, 4, POS_LIGNE);
    }
    affiche_champ(pos_op, 2, POS_LIGNE);
    _gotoxy(x_champ[pos_champ], POS_LIGNE);
}

void choix_libelle()
{
    unsigned char   nom_option[9][17] =
                    { "Carte bleue...",   "Retrait CB",
                      "Cheque...",        "Cheque suivant",
                      "Virement...",      "Salaire",
                      "Remboursement...", "Telephone",
                      "Impots" };
    int             i, j, k, xx, yy, pos_opt;

    nb_libelles = 9;
    yy = POS_LIGNE+2;
    if (yy+nb_libelles-1 > 24) yy = POS_LIGNE-nb_libelles;
    xx = x_champ[2];
    print_xy_c(xx, yy-1, BLACK, CYAN, "       CHOIX LIBELLE       ");
    print_xy_c(xx, yy, WHITE, BROWN, " %-25s ", nom_option[0]);
    setcolor(YELLOW, BLUE);
    for (i = 1; i < nb_libelles; i++)
        print_xy(xx, yy+i, " %-25s ", nom_option[i]);
    _gotoxy(xx, yy);
    pos_opt = 0;
    while (1)
    {
        _gotoxy(xx, yy+pos_opt);
        k = mon_getch();
        switch (k)
        {
            case K_ECHAP:
                j = 3;
                for (i = op_debut; i < op_debut+22; i++)
                    affiche_champ(i, 2, j++);
                _gotoxy(x_champ[pos_champ], POS_LIGNE);
                return;
            case K_RETURN:
                j = 3;
                for (i = op_debut; i < op_debut+22; i++)
                    affiche_champ(i, 2, j++);
                switch (pos_opt)
                {
                    case 0:carte_bleue(); return;
                    case 3:cheque_suivant(); return;
                }
                if (nb_undo == NB_MAX_UNDO) decaler_undos();
                undo[nb_undo].u_code = U_MODIFIER_LIBELLE;
                undo[nb_undo].u_no_op = pos_op;
                undo[nb_undo].u_op_creee = (pos_op == nb_op);
                strcpy(undo[nb_undo].u_op.libelle, op[pos_op].libelle);
                nb_undo++;
                if (pos_op == nb_op)
                {
                    lit_date_systeme();
                    op[pos_op].jour = jour_systeme;
                    op[pos_op].mois = mois_systeme;
                    op[pos_op].annee = annee_systeme;
                    op[pos_op].montant = 0;
                    if (pos_op > 0)
                        solde_apres[pos_op] = solde_apres[pos_op-1];
                    else
                        solde_apres[pos_op] = 0;
                    nb_op++;
                    affiche_champ(pos_op, 0, POS_LIGNE);
                    affiche_champ(pos_op, 4, POS_LIGNE);
                    if (POS_LIGNE != 3)
                        affiche_champ(pos_op-1, 4, POS_LIGNE-1);
                }
                switch (pos_opt)
                {
                    case 1:strcpy(op[pos_op].libelle, "Retrait CB"); break;
                    case 2:strcpy(op[pos_op].libelle, "Cheque"); break;
                    case 4:strcpy(op[pos_op].libelle, "Virement"); break;
                    case 5:strcpy(op[pos_op].libelle, "Salaire"); break;
                    case 6:strcpy(op[pos_op].libelle, "Remboursement"); break;
                    case 7:strcpy(op[pos_op].libelle, "Telephone"); break;
                    case 8:strcpy(op[pos_op].libelle, "Impots"); break;
                }
                affiche_champ(pos_op, 2, POS_LIGNE);
                _gotoxy(x_champ[pos_champ], POS_LIGNE);
                modif = 1;
                affiche_pos();
                return;
            case K_HAUT:
                if (pos_opt > 0)
                {
                    print_xy_c(xx, yy+pos_opt, YELLOW, BLUE, " %-25s ", nom_option[pos_opt]);
                    pos_opt--;
                    print_xy_c(xx, yy+pos_opt, WHITE, BROWN, " %-25s ", nom_option[pos_opt]);
                }
                break;
            case K_BAS:
                if (pos_opt < nb_libelles-1)
                {
                    print_xy_c(xx, yy+pos_opt, YELLOW, BLUE, " %-25s ", nom_option[pos_opt]);
                    pos_opt++;
                    print_xy_c(xx, yy+pos_opt, WHITE, BROWN, " %-25s ", nom_option[pos_opt]);
                }
                break;
        }
    }
}

// ----------------------------------------------------------------------------

void groupe_precedent()
{
    int     i, old_op;

    if (pos_op == 0) return;
    old_op = pos_op;
    if (op[pos_op].pointe != op[pos_op-1].pointe) pos_op--;
    i = pos_op;
    while ( (i >= 0) && (op[i].pointe == op[pos_op].pointe) ) i--;
    pos_op = i+1;
    if (pos_op < op_debut)
    {
        calcul_op_debut();
        affiche_ecran();
    }
    else
    {
        affiche_op(old_op);
        affiche_op(pos_op);
    }
}

void groupe_suivant()
{
    int     i, old_op;

    if (pos_op >= nb_op-1) return;
    old_op = pos_op;
    i = pos_op;
    while ( (i < nb_op) && (op[i].pointe == op[pos_op].pointe) ) i++;
    pos_op = i;
    if (pos_op > op_debut+20)
    {
        calcul_op_debut();
        affiche_ecran();
    }
    else
    {
        affiche_op(old_op);
        affiche_op(pos_op);
    }
}

void echange_op_haut()
{
    t_op    op_temp;

    if (pos_op == 0) return;
    if ( (op[pos_op].jour != op[pos_op-1].jour)
        || (op[pos_op].mois != op[pos_op-1].mois)
        || (op[pos_op].annee != op[pos_op-1].annee) ) return;
    memcpy(&op_temp, &op[pos_op], sizeof(t_op));
    memcpy(&op[pos_op], &op[pos_op-1], sizeof(t_op));
    memcpy(&op[pos_op-1], &op_temp, sizeof(t_op));
    pos_op--;
    //op[pos_op].solde_apres = op[pos_op-1].solde_apres+op[pos_op].montant;
    //op[pos_op+1].solde_apres = op[pos_op].solde_apres+op[pos_op+1].montant;
    calculs();
    if (pos_op == op_debut-1)
    {
        op_debut--;
        affiche_ecran();
    }
    else
    {
        affiche_op(pos_op+1);
        affiche_op(pos_op);
    }
}

void echange_op_bas()
{
    t_op    op_temp;

    if (pos_op >= nb_op-1) return;
    if ( (op[pos_op].jour != op[pos_op+1].jour)
        || (op[pos_op].mois != op[pos_op+1].mois)
        || (op[pos_op].annee != op[pos_op+1].annee) ) return;
    memcpy(&op_temp, &op[pos_op], sizeof(t_op));
    memcpy(&op[pos_op], &op[pos_op+1], sizeof(t_op));
    memcpy(&op[pos_op+1], &op_temp, sizeof(t_op));
    pos_op++;
    //op[pos_op-1].solde_apres = op[pos_op-2].solde_apres+op[pos_op-1].montant;
    //op[pos_op].solde_apres = op[pos_op-1].solde_apres+op[pos_op].montant;
    calculs();
    if (pos_op > op_debut+20)
    {
        op_debut++;
        affiche_ecran();
    }
    else
    {
        affiche_op(pos_op-1);
        affiche_op(pos_op);
    }
}

// ----------------------------------------------------------------------------

void _undo()
{
    int     i;
    t_op    op_temp;

    nb_undo--;
    switch(undo[nb_undo].u_code)
    {
        case U_RECREER_OP:
            if (undo[nb_undo].u_no_op < nb_op-1)
                for (i = nb_op; i > undo[nb_undo].u_no_op; i--)
                    memcpy(&op[i], &op[i-1], sizeof(t_op));
            i = undo[nb_undo].u_no_op;
            op[i].jour = undo[nb_undo].u_op.jour;
            op[i].mois = undo[nb_undo].u_op.mois;
            op[i].annee = undo[nb_undo].u_op.annee;
            op[i].pointe = 0;   // car on ne peut pas effacer une op. pointee
            strcpy(op[i].libelle, undo[nb_undo].u_op.libelle);
            op[i].montant = undo[nb_undo].u_op.montant;
            nb_op++;
            calculs();
            affiche_ecran();
            break;
        case U_EFFACER_OP:
            if (undo[nb_undo].u_no_op == nb_op-1)
            {
                op[nb_op-1].pointe = 0;
                op[nb_op-1].libelle[0] = '\0';
                op[nb_op-1].montant = 0;
                nb_op--;
            }
            else
            {
                memcpy(&op[undo[nb_undo].u_no_op],
                    &op[undo[nb_undo].u_no_op+1],
                    sizeof(t_op)*(nb_op-undo[nb_undo].u_no_op-1));
                nb_op--;
                op[nb_op].pointe = 0;
                op[nb_op].libelle[0] = '\0';
                op[nb_op].montant = 0;
            }
            if (pos_op > nb_op)
            {
                pos_op--;
                if (POS_LIGNE < 3)
                    calcul_op_debut();
            }
            affiche_ecran();
            break;
        case U_RESTAURER_DATE:
            if (undo[nb_undo].u_op_creee)
            {
                if (undo[nb_undo].u_no_op < nb_op-1)
                    for (i = undo[nb_undo].u_no_op; i < nb_op-1; i++)
                        memcpy(&op[i], &op[i+1], sizeof(t_op));
                nb_op--;
                if (pos_op > nb_op) pos_op--;
                if (POS_LIGNE < 3)
                    calcul_op_debut();
            }
            else
            {
                if (undo[nb_undo].u_no_op != undo[nb_undo].u_old_no_op)
                {
                    memcpy(&op_temp, &op[undo[nb_undo].u_no_op], sizeof(t_op));
                    if (undo[nb_undo].u_no_op > undo[nb_undo].u_old_no_op)
                        for (i = undo[nb_undo].u_no_op;
                            i > undo[nb_undo].u_old_no_op; i--)
                            memcpy(&op[i], &op[i-1], sizeof(t_op));
                    else
                        for (i = undo[nb_undo].u_no_op;
                            i < undo[nb_undo].u_old_no_op; i++)
                            memcpy(&op[i], &op[i+1], sizeof(t_op));
                    memcpy(&op[undo[nb_undo].u_old_no_op], &op_temp, sizeof(t_op));
                }
                op[undo[nb_undo].u_old_no_op].jour = undo[nb_undo].u_op.jour;
                op[undo[nb_undo].u_old_no_op].mois = undo[nb_undo].u_op.mois;
                op[undo[nb_undo].u_old_no_op].annee = undo[nb_undo].u_op.annee;
                // deplace_date();
            }
            calculs();
            affiche_ecran();
            break;
        case U_MODIFIER_LIBELLE:
        case U_RESTAURER_LIBELLE:
            if (undo[nb_undo].u_op_creee)
                nb_op--;
            else
                strcpy(op[undo[nb_undo].u_no_op].libelle,
                    undo[nb_undo].u_op.libelle);
            if (pos_op > nb_op) pos_op--;
            affiche_ecran();
            break;
        case U_MODIFIER_MONTANT:
        case U_RESTAURER_MONTANT:
            if (undo[nb_undo].u_op_creee)
                nb_op--;
            else
                op[undo[nb_undo].u_no_op].montant = undo[nb_undo].u_op.montant;
            if (pos_op > nb_op) pos_op--;
            calculs();
            affiche_ecran();
            break;
        case U_REPOINTER:
            op[undo[nb_undo].u_no_op].pointe = 1;
            calculs();
            affiche_ecran();
            break;
        case U_DEPOINTER:
            op[undo[nb_undo].u_no_op].pointe = 0;
            calculs();
            affiche_ecran();
            break;
        case U_ANNULER_RECOPIER:
            break;
    }
    if ( (nb_undo == 0) && (nb_max_undo_depasse == 0) ) modif = 0;
    affiche_pos();
}

void affiche_modifs(int debut_modif)
{
    int     i, ligne;

    setcolor(LIGHTGRAY, BLACK);
    ligne = 3;
    for (i = debut_modif; i < debut_modif+22; i++)
    {
        if (i >= nb_undo)
            print_xy(1, ligne, "                 ");
        else
            print_xy(1, ligne, "%8d  %6d  ", i+1, undo[i].u_no_op+1);
        if (i < nb_undo)
            switch (undo[i].u_code)
            {
                case U_RECREER_OP:
                    print_xy(21, ligne, "Suppression opration");
                    break;
                case U_EFFACER_OP:
                    print_xy(21, ligne, "Insertion nouvelle opration");
                    break;
                case U_RESTAURER_DATE:
                    print_xy(21, ligne, "Modification date");
                    break;
                case U_MODIFIER_LIBELLE:
                    print_xy(21, ligne, "Modification libell");
                    break;
                case U_RESTAURER_LIBELLE:
                    print_xy(21, ligne, "Suppression libell");
                    break;
                case U_MODIFIER_MONTANT:
                    print_xy(21, ligne, "Modification montant");
                    break;
                case U_RESTAURER_MONTANT:
                    print_xy(21, ligne, "Suppression montant");
                    break;
                case U_REPOINTER:
                    print_xy(21, ligne, "Pointage opration");
                    break;
                case U_DEPOINTER:
                    print_xy(21, ligne, "Annulation pointage");
                    break;
                case U_ANNULER_RECOPIER:
                    break;
            }
        clrtoeol();
        ligne++;
    }
    _gotoxy(1, 3);
}

void liste_modifs()
{
    print_xy_c(1, 2, BLUE, CYAN, " Nmodif   Nop                 Description de la modification                ");
    print_xy_c(2, 25, RED, LIGHTGRAY, "ECHAP ");
    print_xy_c(8, 25, BLACK, LIGHTGRAY, "Retour                       ");
    affiche_modifs(0);
    mon_getch();
    affiche_libelles();
    affiche_touches();
    affiche_barres();
    affiche_ecran();
}

void affiche_champ_special(int no_op, int no_champ, int c_texte, int c_fond)
{
    int     ligne;

    if ( (no_op < op_debut) || (no_op > op_debut+21) ) return;
    ligne = 3+(no_op-op_debut);
    setcolor(c_texte, c_fond);
    if (no_op > nb_op-1)
        switch (no_champ)
        {
            case  0:
                print_xy(x_champ[no_champ], ligne, "            ");
                setcolor(LIGHTGRAY, BLACK);
                print_xy(x_champ[no_champ]+12, ligne, "");
                break;
            case  1:
                print_xy(x_champ[no_champ], ligne, "   ");
                break;
            case  2:
                print_xy(x_champ[no_champ], ligne,
                    "                           ");
                break;
            case  3:
                print_xy(x_champ[no_champ], ligne, "           ");
                print_xy(x_champ[3]+12, ligne, "           ");
                break;
            case  4:
                print_xy(x_champ[no_champ], ligne, "           ");
                x_curseur = 80;
                y_curseur--;
                print_xy_c(x_champ[no_champ]-1, ligne, LIGHTGRAY, BLACK, "");
                break;
        }
    else
        switch (no_champ)
        {
            case  0:
                print_xy(x_champ[no_champ], ligne,
                    " %02d/%02d/%04d ", op[no_op].jour,
                    op[no_op].mois, op[no_op].annee);
                if ( (no_op == 0) || (op[no_op].mois != op[no_op-1].mois) )
                    print_xy_c(x_champ[no_champ]+12, ligne, LIGHTGRAY, BLACK, "");
                else
                    print_xy_c(x_champ[no_champ]+12, ligne, LIGHTGRAY, BLACK, "");
                break;
            case  1:
                if (op[no_op].pointe)
                    print_xy(x_champ[no_champ], ligne, " x ");
                else
                    print_xy(x_champ[no_champ], ligne, "   ");
                break;
            case  2:
                print_xy(x_champ[no_champ], ligne, " %-26s",
                    op[no_op].libelle);
                break;
            case  3:
                if (op[no_op].montant < 0)
                {
                    if (euro)
                        print_xy(x_champ[no_champ], ligne, "%10.2f ",
                            -op[no_op].montant/taux_euro);
                    else
                        print_xy(x_champ[no_champ], ligne, "%10.2f ",
                            -op[no_op].montant);
                }
                else
                    print_xy(x_champ[no_champ], ligne, "           ");
                if (op[no_op].montant > 0)
                {
                    if (euro)
                        print_xy(x_champ[3]+12, ligne, "%10.2f ",
                            op[no_op].montant/taux_euro);
                    else
                        print_xy(x_champ[3]+12, ligne, "%10.2f ",
                            op[no_op].montant);
                }
                else
                    print_xy(x_champ[3]+12, ligne, "           ");
                break;
            case  4:
                if (euro)
                    print_xy(x_champ[no_champ], ligne, "%10.2f ",
                        solde_apres[no_op]/taux_euro);
                else
                    print_xy(x_champ[no_champ], ligne, "%10.2f ",
                        solde_apres[no_op]);
                x_curseur = 80;
                y_curseur--;
                if ( (no_op == 0) || (op[no_op].mois != op[no_op-1].mois) )
                    print_xy_c(x_champ[no_champ]-1, ligne, LIGHTGRAY, BLACK, "");
                else
                    print_xy_c(x_champ[no_champ]-1, ligne, LIGHTGRAY, BLACK, "");
                break;
        }
    if ( (no_op == pos_op) && (no_champ == pos_champ) )
        _gotoxy(x_champ[pos_champ], POS_LIGNE);
}

void modifs_couleur()
{
    int     i;

    efface_barre_selection();
    for (i = 0; i < nb_undo; i++)
        switch (undo[i].u_code)
        {
            case U_RECREER_OP:
                break;
            case U_EFFACER_OP:
                break;
            case U_RESTAURER_DATE:
                affiche_champ_special(undo[i].u_no_op, 0, c_modif, c_modif_f);
                break;
            case U_RESTAURER_LIBELLE:
                affiche_champ_special(undo[i].u_no_op, 2, c_modif, c_modif_f);
                break;
            case U_RESTAURER_MONTANT:
                affiche_champ_special(undo[i].u_no_op, 3, c_modif, c_modif_f);
                break;
            case U_REPOINTER:
                affiche_champ_special(undo[i].u_no_op, 1, c_modif, c_modif_f);
                break;
            case U_DEPOINTER:
                affiche_champ_special(undo[i].u_no_op, 1, c_modif, c_modif_f);
                break;
            case U_ANNULER_RECOPIER:
                break;
        }
    _gotoxy(x_champ[pos_champ], POS_LIGNE);
    mon_getch();
    affiche_ecran();
}

// ----------------------------------------------------------------------------

// variables utilisees pour la recherche (sous-liste, SL)

unsigned char   SL_critere_date;
int             SL_jour_debut, SL_mois_debut, SL_annee_debut;
int             SL_jour_fin,   SL_mois_fin,   SL_annee_fin;
int             SL_mois, SL_annee;
unsigned char   SL_date_jusqua_fin;
signed char     SL_critere_pointe;
unsigned char   SL_critere_libelle;
unsigned char   SL_libelle_environ_egal;
unsigned char   SL_libelle[27];
unsigned char   SL_ignorer_casse;
unsigned char   SL_critere_montant;
unsigned char   SL_montant_supinfegal;
double          SL_montant;
unsigned char   SL_montant_valabs;
unsigned char   SL_monnaie;

int             SL_y, SL_x;

int             SL_nb_opt_x[7] = { 9, 3, 2, 1, 4, 5, 1 };
int             SL_x_opt[7][9] = { { 8, 19, 28, 31, 34, 42, 45, 48, 53 },
                                   { 19, 31, 41, 0, 0, 0, 0, 0, 0 },
                                   { 8, 13, 0, 0, 0, 0, 0, 0, 0 },
                                   { 13, 0, 0, 0, 0, 0, 0, 0, 0 },
                                   { 8, 21, 24, 53, 0, 0, 0, 0, 0 },
                                   { 8, 21, 25, 37, 47, 0, 0, 0, 0 },
                                   { 32, 0, 0, 0, 0, 0, 0, 0, 0 } };
int             SL_y_opt[7] = { 9, 10, 12, 13, 15, 18, 20 };

                // numero du champ cible quand la fleche haute est enfoncee
                // le chiffre des dizaines indique la ligne, et le chiffre
                // des unites indique la colonne
                // (ici les lignes et colonnes commencent a 1)
int             SL_K_HAUT[7][9] = { {  0,  0,  0,  0,  0,  0,  0,  0,  0 },
                                    { 12, 14, 15,  0,  0,  0,  0,  0,  0 },
                                    { 11, 21,  0,  0,  0,  0,  0,  0,  0 },
                                    { 32,  0,  0,  0,  0,  0,  0,  0,  0 },
                                    { 31, 41, 41, 41,  0,  0,  0,  0,  0 },
                                    { 51, 52, 53, 53, 53,  0,  0,  0,  0 },
                                    { 61,  0,  0,  0,  0,  0,  0,  0,  0 } };

int             SL_K_BAS[7][9] =  { { 31, 21, 22, 22, 23, 23, 23, 23, 23 },
                                    { 32, 32, 32,  0,  0,  0,  0,  0,  0 },
                                    { 51, 41,  0,  0,  0,  0,  0,  0,  0 },
                                    { 51,  0,  0,  0,  0,  0,  0,  0,  0 },
                                    { 61, 62, 63, 65,  0,  0,  0,  0,  0 },
                                    { 71, 71, 71, 71, 71,  0,  0,  0,  0 },
                                    {  0,  0,  0,  0,  0,  0,  0,  0,  0 } };


int             SL_pos;

// SL_affiche_SL: affiche la liste des operations trouvees (sous-liste = SL)

void SL_affiche_SL(int debut)
{
    int     i, j, fin, ligne;

    setcolor(LIGHTGRAY, BLACK);
    ligne = 3;
    fin = debut+21;
    for (i = debut; i <= fin; i++)
    {
        if (i < SL_nb_op)
        {
            j = SL_no_op[i];

            print_xy(x_champ[0], ligne, " %02d/%02d/%4d ", op[j].jour, op[j].mois,
                op[j].annee);

            if (op[j].pointe)
                print_xy(x_champ[1], ligne, " x ");
            else
                print_xy(x_champ[1], ligne, "   ");

            print_xy(x_champ[2], ligne, " %-26s", op[j].libelle);

            if (op[j].montant < 0)
            {
                if (euro)
                    print_xy(x_champ[3], ligne, "%10.2f ",
                        -op[j].montant/taux_euro);
                else
                    print_xy(x_champ[3], ligne, "%10.2f ",
                        -op[j].montant);
            }
            else
                print_xy(x_champ[3], ligne, "           ");
            if (op[j].montant > 0)
            {
                if (euro)
                    print_xy(x_champ[3]+12, ligne, "%10.2f ",
                        op[j].montant/taux_euro);
                else
                    print_xy(x_champ[3]+12, ligne, "%10.2f ",
                        op[j].montant);
            }
            else
                print_xy(x_champ[3]+12, ligne, "           ");

            if (euro)
                print_xy(x_champ[4], ligne, "%10.2f ", solde_apres[j]/taux_euro);
            else
                print_xy(x_champ[4], ligne, "%10.2f ", solde_apres[j]);
        }
        else
            print_xy(x_champ[0], ligne, "                                                                           ");
        ligne++;
    }
    if (SL_nb_op <= 22)
        print_xy_c(64, 25, BLACK, LIGHTGRAY, "* FIN *");
    else
        if (SL_pos == 0)
            print_xy_c(64, 25, BLACK, LIGHTGRAY, "* DEBUT *");
        else
            if (SL_pos+22 == SL_nb_op)
                print_xy_c(64, 25, BLACK, LIGHTGRAY, "** FIN **");
            else
                print_xy_c(64, 25, BLACK, LIGHTGRAY, "         ");
    _gotoxy(1, 3);
}

// SL_erreur_rien_trouve: message d'erreur si aucune operation trouvee

void SL_erreur_rien_trouve()
{
    int     i, k;

    setcolor(WHITE, RED);
    print_xy(23,  9, "                                  ");
    print_xy(23, 10, "    FIN DE RECHERCHE    ");
    setcolor(YELLOW, RED);
    print_xy(23, 11, "                                  ");
    print_xy(23, 12, "  Aucune opration ne correspond  ");
    print_xy(23, 13, "       aux critres fournis.      ");
    print_xy(23, 14, "                                  ");
    print_xy(23, 15, "                                  ");
    print_xy(23, 16, "                                  ");
    print_xy(23, 17, "                                  ");
    print_xy_c(35, 15, WHITE, BLUE, "    OK    ");
    print_xy_c(45, 15, BLACK, RED, "");
    print_xy(36, 16, "");
    print_xy_c(25, 18, BROWN, BLACK, "");
    for (i = 10; i < 18; i++) print_xy(57, i, "");
    _gotoxy(35, 15);
    while (1)
    {
        k = mon_getch();
        if ( (k == K_RETURN) || (k == K_ECHAP) )
            return;
    }
}

// SL_loop: deplacement dans la fenetre de resultat de recherche

int SL_loop(int type_recherche)
{
    int     i, k, operation_debut;

    if (type_recherche == RECHERCHE_GLOBALE)
        operation_debut = 0;
    else
        operation_debut = deb_op_aff;

    print_xy_c(50, 1, LIGHTGRAY, BLUE, "      Somme totale");
    if (SL_nb_op == 0)
        print_xy_c(70, 1, GREEN, BLUE, "0          ");
    else
        if (euro)
            print_xy_c(70, 1, GREEN, BLUE, "%-10.2f",
                solde_apres[SL_no_op[SL_nb_op-1]]/taux_euro);
        else
            print_xy_c(70, 1, GREEN, BLUE, "%-10.2f",
                solde_apres[SL_no_op[SL_nb_op-1]]);
    print_xy_c(71, 2, BLUE, CYAN, "  Somme  ");

    _gotoxy(2, 25);
    setcolor(RED, LIGHTGRAY);   print( "F1 ");
    setcolor(BLACK, LIGHTGRAY); print("Aide ");
    setcolor(RED, LIGHTGRAY);   print(" ECHAP ");
    setcolor(BLACK, LIGHTGRAY); print("Retour       ");

    print_xy_c(29, 25, BLUE, LIGHTGRAY, "%5d ", SL_nb_op);
    if (SL_nb_op > 1)
        print_xy_c(35, 25, BLACK, LIGHTGRAY, "oprations trouves          ");
    else
        print_xy_c(35, 25, BLACK, LIGHTGRAY, "opration trouve            ");

    SL_pos = 0;
    SL_affiche_SL(SL_pos);

    if (SL_nb_op == 0)
    {
        SL_erreur_rien_trouve();
        print_xy_c(54, 1, LIGHTGRAY, BLUE, " non point(s): ");
        print_xy_c(73, 2, BLUE, CYAN, "Solde");
        affiche_touches();
        calculs();
        affiche_barres();
        affiche_ecran();
        return 1;
    }

    while (1)
    {
        k = mon_getch();
        switch (k)
        {
            case K_ECHAP:               // Echap = retour au mode normal
                return 0;
            case K_F5:                  // F5 = nouvelle recherche immediate
                return 1;
            case 'm':
            case 'M':                   // "M" = marquer operations trouvees
                for (i = 0; i < SL_nb_op; i++)
                    if (op[SL_no_op[i]].couleur == 0)
                    {
                        nb_mark++;
                        somme_mark += op[SL_no_op[i]].montant;
                        op[SL_no_op[i]].couleur = 1;
                    }
                return 0;
            case K_HAUT:
                if (SL_pos > 0)
                    SL_affiche_SL(--SL_pos);
                break;
            case K_BAS:
                if (SL_pos+22 < SL_nb_op)
                    SL_affiche_SL(++SL_pos);
                break;
            case K_HOME:
                if (SL_pos != 0)
                {
                    SL_pos = 0;
                    SL_affiche_SL(0);
                }
                break;
            case K_END:
                if (SL_nb_op > 22)
                    if (SL_pos != SL_nb_op-22)
                    {
                        SL_pos = SL_nb_op-22;
                        SL_affiche_SL(SL_pos);
                    }
                break;
            case K_PGUP:
                if ( (SL_nb_op > 22) && (SL_pos != 0) )
                {
                    if (SL_pos < 22)
                        SL_pos = 0;
                    else
                        SL_pos -= 22;
                    SL_affiche_SL(SL_pos);
                }
                break;
            case K_PGDN:
                if (SL_nb_op > 22)
                    if (SL_pos != SL_nb_op-22)
                    {
                        SL_pos += 22;
                        if (SL_pos > SL_nb_op-22)
                            SL_pos = SL_nb_op-22;
                        SL_affiche_SL(SL_pos);
                    }
                break;
            #ifdef MSDOS
            case 'e':
            case 'E':                   // Alt-E = basculer EUROS / FRANCS
            #else
            case 201:
            #endif
                if (alt)
                {
                    euro ^= 1;
                    if (euro)
                        print_xy_c(74, 25, BLUE, LIGHTGRAY, " EUROS");
                    else
                        print_xy_c(74, 25, BLUE, LIGHTGRAY, "FRANCS");
                    affiche_statut(0);
                    if (euro)
                        print_xy_c(70, 1, GREEN, BLUE, "%-10.2f",
                            solde_apres[SL_no_op[SL_nb_op-1]]/taux_euro);
                    else
                        print_xy_c(70, 1, GREEN, BLUE, "%-10.2f",
                            solde_apres[SL_no_op[SL_nb_op-1]]);
                    SL_affiche_SL(SL_pos);
                }
        }
    }
}

// SL_selectionne_operations: recherche proprement dite

void SL_selectionne_operations(int type_recherche)
{
    int             i, j, operation_debut;
    unsigned char   op_lib[27], SL_lib[27];
    double          taux, montant;

    SL_nb_op = 0;
    // verification des criteres pour chaque operation
    strcpy(SL_lib, SL_libelle);
    if (SL_ignorer_casse)
    {
        for (j = strlen(SL_lib)-1; j >= 0; j--)
            if ( (SL_lib[j] >= 'a') && (SL_lib[j] <= 'z') )
                SL_lib[j] -= ('a'-'A');
            else
                if (SL_lib[j] == 138) SL_lib[j] = 'E';
    }
    if (SL_monnaie == MONNAIE_EUROS)
        taux = 6.5;
    else
        taux = 1;
    if (type_recherche == RECHERCHE_GLOBALE)
        operation_debut = 0;
    else
        operation_debut = deb_op_aff;
    for (i = operation_debut; i < nb_op; i++)
    {
        if (SL_critere_date == 1)
        {
            if (quantieme(op[i].jour, op[i].mois, op[i].annee) <
                quantieme(SL_jour_debut, SL_mois_debut, SL_annee_debut))
                continue;
            if (!SL_date_jusqua_fin)
                if (quantieme(op[i].jour, op[i].mois, op[i].annee) >
                    quantieme(SL_jour_fin, SL_mois_fin, SL_annee_fin))
                    continue;
        }
        else
            if (SL_critere_date == 2)
                if ( (op[i].mois != SL_mois) || (op[i].annee != SL_annee) )
                    continue;
        if (SL_critere_pointe >= 0)
            if (op[i].pointe != SL_critere_pointe)
                continue;
        if (SL_critere_libelle)
        {
            strcpy(op_lib, op[i].libelle);
            if (SL_ignorer_casse)
            {
                for (j = strlen(op_lib)-1; j >= 0; j--)
                    if ( (op_lib[j] >= 'a') && (op_lib[j] <= 'z') )
                        op_lib[j] -= ('a'-'A');
                    else
                        if (op_lib[j] == 138) op_lib[j] = 'E';
            }
            if (SL_libelle_environ_egal)
            {
                if (strstr(op_lib, SL_lib) == NULL)
                    continue;
            }
            else
                if (strcmp(op_lib, SL_lib) != 0)
                    continue;
        }
        if (SL_critere_montant)
        {
            if (SL_montant_valabs)
                montant = fabs(op[i].montant);
            else
                montant = op[i].montant;
            switch (SL_montant_supinfegal)
            {
                case MONTANT_INF:
                    if (montant/taux >= SL_montant)
                        continue;
                    break;
                case MONTANT_INF_EGAL:
                    if (montant/taux > SL_montant)
                        continue;
                    break;
                case MONTANT_EGAL:
                    if (montant/taux != SL_montant)
                        continue;
                    break;
                case MONTANT_SUP_EGAL:
                    if (montant/taux < SL_montant)
                        continue;
                    break;
                case MONTANT_SUP:
                    if (montant/taux <= SL_montant)
                        continue;
                    break;
            }
        }
        SL_no_op[SL_nb_op] = i;
        SL_nb_op++;
    }

    // calcul des sommes des operations dans le champ "Solde apres"
    // Le "Solde apres" disparait et sera recalcule avant de revenir
    // a la liste complete
    if (SL_nb_op > 0)
    {
        solde_apres[SL_no_op[0]] = op[SL_no_op[0]].montant;
        for (i = 1; i < SL_nb_op; i++)
            solde_apres[SL_no_op[i]] =
                solde_apres[SL_no_op[i-1]]+op[SL_no_op[i]].montant;
    }
}

// SL_edite_libelle: edite le libelle dans la boite de dialogue "Rechercher"

int SL_edite_libelle()
{
    int     res;

    res = edite_chaine(SL_x_opt[SL_y][SL_x], SL_y_opt[SL_y], 27, 26, YELLOW,
        MAGENTA, SL_libelle, SL_libelle);
    print_xy_c(SL_x_opt[SL_y][SL_x]+26, SL_y_opt[SL_y], WHITE, BLUE, " ");
    return res;
}

// SL_edite_montant: edite le montant dans la boite de dialogue "Rechercher"

int SL_edite_montant()
{
    unsigned char   chaine[21], result[21];
    double          nouveau_montant;
    int             res, res2;

    montant_en_chaine(chaine, SL_montant);
    if (strcmp(chaine, "0") == 0)
        chaine[0] = '\0';
    res = edite_chaine(SL_x_opt[SL_y][SL_x], SL_y_opt[SL_y], 12, 11, YELLOW, MAGENTA,
        chaine, result);
    nouveau_montant = 0;
    nouveau_montant = atof(result);
/*    if (SL_monnaie == MONNAIE_EUROS)
        nouveau_montant = nouveau_montant*taux_euro; */
    if ( (nouveau_montant >= -9999999.99) && (nouveau_montant <= 9999999.99)
        && (res) )
    {
        SL_montant = nouveau_montant;
        res2 = 1;
    }
    else
        res2 = 0;
    print_xy_c(SL_x_opt[SL_y][SL_x]+11, SL_y_opt[SL_y], WHITE, BLUE, " ");
    return res2;
}

// SL_affiche_champ: affiche un champ dans la boite de dialogue "Rechercher"

void SL_affiche_champ(int x, int y)
{
    unsigned char   i, chaine[27];
    int             xx, yy;

    if ( (x == 0) && (y == 6) )
    {
        if (SL_y == 6)
            setcolor(WHITE, RED);
        else
            setcolor(BLACK, CYAN);
    }
    else
        if ( (x == 0) && (y != 1) && (y != 3) )
        {
            if ( (y == SL_y) && (x == SL_x) )
                setcolor(LIGHTGREEN, RED);
            else
                setcolor(LIGHTGREEN, BLUE);
        }
        else
            if ( (y == SL_y) && (x == SL_x) )
                setcolor(YELLOW, RED);
            else
                setcolor(YELLOW, BLUE);
    xx = SL_x_opt[y][x];
    yy = SL_y_opt[y];
    switch (y)
    {
        case 0:
            switch (x)
            {
                case 0:
                    if (SL_critere_date != 0)
                        print_xy(xx, yy, " [x] ");
                    else
                        print_xy(xx, yy, " [ ] ");
                    break;
                case 1:
                    if (SL_critere_date == 1)
                        print_xy(xx, yy, " (o) ");
                    else
                        print_xy(xx, yy, " ( ) ");
                    break;
                case 2:
                    print_xy(xx, yy, "%02d", SL_jour_debut);
                    break;
                case 3:
                    print_xy(xx, yy, "%02d", SL_mois_debut);
                    break;
                case 4:
                    print_xy(xx, yy, "%4d", SL_annee_debut);
                    break;
                case 5:
                    if (SL_date_jusqua_fin)
                        print_xy(xx, yy, "--");
                    else
                        print_xy(xx, yy, "%02d", SL_jour_fin);
                    break;
                case 6:
                    if (SL_date_jusqua_fin)
                        print_xy(xx, yy, "--");
                    else
                        print_xy(xx, yy, "%02d", SL_mois_fin);
                    break;
                case 7:
                    if (SL_date_jusqua_fin)
                        print_xy(xx, yy, "----");
                    else
                        print_xy(xx, yy, "%4d", SL_annee_fin);
                    break;
                case 8:
                    if (SL_date_jusqua_fin)
                        print_xy(xx, yy, " [x] ");
                    else
                        print_xy(xx, yy, " [ ] ");
                    break;
            }
            break;
        case 1:
            switch (x)
            {
                case 0:
                    if (SL_critere_date == 2)
                        print_xy(xx, yy, " (o) ");
                    else
                        print_xy(xx, yy, " ( ) ");
                    break;
                case 1:
                    //print_xy(xx, yy, "%02d", SL_mois);
                    print_xy(xx, yy, "%9s", nom_mois[SL_mois-1]);
                    break;
                case 2:
                    print_xy(xx, yy, "%4d", SL_annee);
                    break;
            }
            break;
        case 2:
            switch (x)
            {
                case 0:
                    if (SL_critere_pointe < 0)
                        print_xy(xx, yy, " [ ] ");
                    else
                        print_xy(xx, yy, " [x] ");
                    break;
                case 1:
                    if (SL_critere_pointe == 1)
                        print_xy(xx, yy, " (o) ");
                    else
                        print_xy(xx, yy, " ( ) ");
                    break;
            }
            break;
        case 3:
            if (x == 0)
            {
                if (SL_critere_pointe == 0)
                    print_xy(xx, yy, " (o) ");
                else
                    print_xy(xx, yy, " ( ) ");
            }
            break;
        case 4:
            switch (x)
            {
                case 0:
                    if (SL_critere_libelle)
                        print_xy(xx, yy, " [x] ");
                    else
                        print_xy(xx, yy, " [ ] ");
                    break;
                case 1:
                    if (SL_libelle_environ_egal == 1)
                        print_xy(xx, yy, "  ");
                    else
                        print_xy(xx, yy, " = ");
                    break;
                case 2:
                    strcpy(chaine, SL_libelle);
                    if (strlen(chaine) < 26)
                    {
                        for (i = strlen(chaine); i < 26; i++)
                            chaine[i] = '_';
                        chaine[26] = '\0';
                    }
                    print_xy(xx, yy, "%s", chaine);
                    break;
                case 3:
                    if (SL_ignorer_casse)
                        print_xy(xx, yy, " [x] ");
                    else
                        print_xy(xx, yy, " [ ] ");
                    break;
            }
            break;
        case 5:
            switch (x)
            {
                case 0:
                    if (SL_critere_montant)
                        print_xy(xx, yy, " [x] ");
                    else
                        print_xy(xx, yy, " [ ] ");
                    break;
                case 1:
                    switch (SL_montant_supinfegal)
                    {
                        case MONTANT_INF:
                            print_xy(xx, yy, " <  ");
                            break;
                        case MONTANT_INF_EGAL:
                            print_xy(xx, yy, " <= ");
                            break;
                        case MONTANT_EGAL:
                            print_xy(xx, yy, "  = ");
                            break;
                        case MONTANT_SUP_EGAL:
                            print_xy(xx, yy, " >= ");
                            break;
                        case MONTANT_SUP:
                            print_xy(xx, yy, " >  ");
                            break;
                    }
                    break;
                case 2:
                    sprintf(chaine, "%.2f", SL_montant);
                    if (strlen(chaine) < 11)
                    {
                        for (i = strlen(chaine); i < 11; i++)
                            chaine[i] = '_';
                        chaine[11] = '\0';
                    }
                    print_xy(xx, yy, "%s", chaine);
                    break;
                case 3:
                    switch (SL_monnaie)
                    {
                        case MONNAIE_FRANCS:
                            print_xy(xx, yy, " Francs ");
                            break;
                        case MONNAIE_EUROS:
                            print_xy(xx, yy, " Euros  ");
                            break;
                    }
                    break;
                case 4:
                    if (SL_montant_valabs)
                        print_xy(xx, yy, " [x] ");
                    else
                        print_xy(xx, yy, " [ ] ");
                    break;
            }
            break;
        case 6:
            print_xy(xx, yy, "  Rechercher  ");
            if ( (SL_critere_date == 0) && (SL_critere_pointe == -1)
                && (SL_critere_libelle == 0) && (SL_critere_montant == 0) )
                if (y == SL_y)
                    print_xy_c(25, yy+2, LIGHTGRAY, BLUE, "! Aucun critre slectionn !");
                else
                    print_xy_c(25, yy+2, LIGHTGRAY, BLUE, "                             ");
            break;
    }
}

void SL_reinitialise_criteres()
{
    SL_critere_date = 0;
    SL_jour_debut = 1;
    SL_mois_debut = op[nb_op-1].mois;
    SL_annee_debut = op[nb_op-1].annee;
    SL_jour_fin = nb_jours[op[nb_op-1].mois-1];
    SL_mois_fin = SL_mois_debut;
    SL_annee_fin = SL_annee_debut;
    SL_mois = SL_mois_debut;
    SL_annee = SL_annee_debut;
    SL_date_jusqua_fin = 0;
    SL_critere_pointe = -1;
    SL_critere_libelle = 0;
    SL_libelle_environ_egal = 1;
    SL_libelle[0] = '\0';
    SL_ignorer_casse = 1;
    SL_critere_montant = 0;
    SL_montant_supinfegal = MONTANT_SUP_EGAL;
    SL_montant = 100;
    if (euro)
        SL_monnaie = MONNAIE_EUROS;
    else
        SL_monnaie = MONNAIE_FRANCS;
    SL_montant_valabs = 0;
}

void SL_affiche_tous_les_champs()
{
    int     i, j;

    for (i = 0; i < 6; i++)
        for (j = 0; j < 9; j++)
            SL_affiche_champ(j, i);
}

void sous_liste(int type_recherche)
{
    int     i, k, Old_x, Old_y;
    int     fin_recherche, nouvelle_recherche;

    nouvelle_recherche = 1;
    while (nouvelle_recherche)
    {
        efface_barre_selection();
        setcolor(WHITE, BLUE);
        print_xy(6,  4, "                                                                    ");
        if (type_recherche == RECHERCHE_GLOBALE)
            print_xy(6,  5, "    RECHERCHE GLOBALE    ");
        else
            print_xy(6,  5, "    RECHERCHE LOCALE    ");
        print_xy(6,  6, "                                                                    ");
        print_xy_c(6,  7, LIGHTGREEN, BLUE, "  Critres de slection des oprations:                             ");
        print_xy_c(6,  8, WHITE, BLUE, "                                                                    ");
        print_xy(6,  9, "   [ ]  Date  ( )  du   /  /     au   /  /      [ ] Jusqu'a la fin  ");
        print_xy(6, 10, "              ( )  mois: Septembre 1998                             ");
        print_xy(6, 11, "                                                                    ");
        print_xy(6, 12, "   [ ]  ( )  Opration pointe                                      ");
        print_xy(6, 13, "        ( )  Opration non pointe                                  ");
        print_xy(6, 14, "                                                                    ");
        print_xy(6, 15, "   [ ]  Libell  __________________________    [ ] Ignorer diff.   ");
        print_xy(6, 16, "                                                    maj/min         ");
        print_xy(6, 17, "                                                                    ");
        print_xy(6, 18, "   [ ]  Montant >= ___________  Francs    [ ] En valeur absolue     ");
        print_xy(6, 19, "                                                                    ");
        print_xy(6, 20, "                                                                    ");
        print_xy(6, 21, "                                                                    ");
        print_xy(6, 22, "                                                                    ");
        print_xy_c(32, 20, BLACK, CYAN, "  Rechercher  ");
        print_xy_c(46, 20, BLACK, BLUE, "");
        print_xy(33, 21, "");
        setcolor(BLUE, BLACK);
        for (i = 5; i < 23; i++) print_xy(74, i, "");
        print_xy(8, 23, "");
        SL_x = 0; SL_y = 0;
        if (fonction_sous_liste == 0)
        {
            fonction_sous_liste = 1;
            SL_reinitialise_criteres();
        }
        SL_affiche_tous_les_champs();
        fin_recherche = 0;
        while (!fin_recherche)
        {
            _gotoxy(SL_x_opt[SL_y][SL_x], SL_y_opt[SL_y]);
            k = mon_getch();
            switch (k)
            {
                case K_ECHAP:
                    fin_recherche = 1;
                    nouvelle_recherche = 0;
                    break;
                case 18:                    // Ctrl-R: reinitialiser criteres
                    if (control)
                    {
                        SL_reinitialise_criteres();
                        SL_affiche_tous_les_champs();
                    }
                    break;
                case K_RETURN:
                    switch (SL_y)
                    {
                        case 4:
                            if (SL_x == 2)
                            {
                                if (SL_edite_libelle())
                                {
                                    SL_critere_libelle = 1;
                                    SL_affiche_champ(0, 4);
                                }
                                SL_affiche_champ(2, 4);
                            }
                            break;
                        case 5:
                            if (SL_x == 2)
                            {
                                if (SL_edite_montant())
                                {
                                    SL_critere_montant = 1;
                                    SL_affiche_champ(0, 5);
                                }
                                SL_affiche_champ(2, 5);
                            }
                            break;
                        case 6:
                            if ( (SL_critere_date != 0) || (SL_critere_pointe != -1)
                                || (SL_critere_libelle != 0)
                                || (SL_critere_montant != 0) )
                            {
                                SL_selectionne_operations(type_recherche);
                                fin_recherche = 1;
                                nouvelle_recherche = SL_loop(type_recherche);
                            }
                    }
                    break;
                case 32:
                    switch (SL_y)
                    {
                        case 0:
                            switch (SL_x)
                            {
                                case 0:
                                    if (SL_critere_date == 0)
                                        SL_critere_date = 1;
                                    else
                                        SL_critere_date = 0;
                                    SL_affiche_champ(0, 0);
                                    SL_affiche_champ(0, 1);
                                    SL_affiche_champ(1, 0);
                                    break;
                                case 1:
                                    SL_critere_date = 1;
                                    SL_affiche_champ(0, 0);
                                    SL_affiche_champ(0, 1);
                                    SL_affiche_champ(1, 0);
                                    break;
                                case 8:
                                    SL_date_jusqua_fin ^= 1;
                                    SL_critere_date = 1;
                                    if (!SL_date_jusqua_fin)
                                        if (quantieme(SL_jour_debut, SL_mois_debut,
                                        SL_annee_debut) > quantieme(SL_jour_fin,
                                        SL_mois_fin, SL_annee_fin))
                                        {
                                            SL_jour_fin = SL_jour_debut;
                                            SL_mois_fin = SL_mois_debut;
                                            SL_annee_fin = SL_annee_debut;
                                        }
                                    SL_affiche_champ(0, 0);
                                    SL_affiche_champ(0, 1);
                                    SL_affiche_champ(1, 0);
                                    SL_affiche_champ(5, 0);
                                    SL_affiche_champ(6, 0);
                                    SL_affiche_champ(7, 0);
                                    SL_affiche_champ(8, 0);
                                    break;
                            }
                            break;
                        case 1:
                            if (SL_x == 0)
                            {
                                SL_critere_date = 2;
                                SL_affiche_champ(0, 0);
                                SL_affiche_champ(0, 1);
                                SL_affiche_champ(1, 0);
                            }
                            break;
                        case 2:
                            switch (SL_x)
                            {
                                case 0:
                                    if (SL_critere_pointe < 0)
                                        SL_critere_pointe = 1;
                                    else
                                        SL_critere_pointe = -1;
                                    SL_affiche_champ(0, 2);
                                    SL_affiche_champ(1, 2);
                                    SL_affiche_champ(0, 3);
                                    break;
                                case 1:
                                    SL_critere_pointe = 1;
                                    SL_affiche_champ(0, 2);
                                    SL_affiche_champ(1, 2);
                                    SL_affiche_champ(0, 3);
                                    break;
                            }
                            break;
                        case 3:
                            if (SL_x == 0)
                            {
                                SL_critere_pointe = 0;
                                SL_affiche_champ(0, 2);
                                SL_affiche_champ(1, 2);
                                SL_affiche_champ(0, 3);
                            }
                            break;
                        case 4:
                            switch (SL_x)
                            {
                                case 0:
                                    SL_critere_libelle ^= 1;
                                    SL_affiche_champ(0, 4);
                                    break;
                                case 1:
                                    SL_libelle_environ_egal ^= 1;
                                    SL_critere_libelle = 1;
                                    SL_affiche_champ(0, 4);
                                    SL_affiche_champ(1, 4);
                                    break;
                                case 2:
                                    if (SL_edite_libelle())
                                    {
                                        SL_critere_libelle = 1;
                                        SL_affiche_champ(0, 4);
                                    }
                                    SL_affiche_champ(2, 4);
                                    break;
                                case 3:
                                    SL_ignorer_casse ^= 1;
                                    SL_critere_libelle = 1;
                                    SL_affiche_champ(0, 4);
                                    SL_affiche_champ(3, 4);
                                    break;
                            }
                            break;
                        case 5:
                            switch (SL_x)
                            {
                                case 0:
                                    SL_critere_montant ^= 1;
                                    SL_affiche_champ(0, 5);
                                    break;
                                case 1:
                                    SL_montant_supinfegal++;
                                    SL_critere_montant = 1;
                                    if (SL_montant_supinfegal > 4)
                                        SL_montant_supinfegal = 0;
                                    SL_affiche_champ(0, 5);
                                    SL_affiche_champ(1, 5);
                                    break;
                                case 2:
                                    if (SL_edite_montant())
                                    {
                                        SL_critere_montant = 1;
                                        SL_affiche_champ(0, 5);
                                    }
                                    SL_affiche_champ(2, 5);
                                    break;
                                case 3:
                                    SL_monnaie ^= 1;
                                    SL_critere_montant = 1;
                                    if (SL_monnaie == MONNAIE_EUROS)
                                        SL_montant /= taux_euro;
                                    else
                                        SL_montant *= taux_euro;
                                    SL_affiche_champ(0, 5);
                                    SL_affiche_champ(2, 5);
                                    SL_affiche_champ(3, 5);
                                    break;
                                case 4:
                                    SL_montant_valabs ^= 1;
                                    SL_critere_montant = 1;
                                    if (SL_montant_valabs)
                                    {
                                        SL_montant = fabs(SL_montant);
                                        SL_affiche_champ(2, 5);
                                    }
                                    SL_affiche_champ(0, 5);
                                    SL_affiche_champ(4, 5);
                                    break;
                            }
                            break;
                    }
                    break;
                case '+':
                    if (SL_y == 0)
                        switch (SL_x)
                        {
                            case 2:
                                if (SL_annee_debut%4 == 0)
                                    nb_jours[1] = 29;
                                else
                                    nb_jours[1] = 28;
                                if (SL_jour_debut < nb_jours[SL_mois_debut-1])
                                    SL_jour_debut++;
                                else
                                {
                                    if (SL_mois_debut == 12)
                                    {
                                        if (SL_annee_debut != 2099)
                                        {
                                            SL_jour_debut = 1;
                                            SL_mois_debut = 1;
                                            SL_annee_debut++;
                                        }
                                    }
                                    else
                                    {
                                        SL_mois_debut++;
                                        SL_jour_debut = 1;
                                    }
                                }
                                SL_critere_date = 1;
                                SL_affiche_champ(0, 0);
                                SL_affiche_champ(0, 1);
                                SL_affiche_champ(1, 0);
                                SL_affiche_champ(2, 0);
                                SL_affiche_champ(3, 0);
                                SL_affiche_champ(4, 0);
                                if (quantieme(SL_jour_debut, SL_mois_debut,
                                    SL_annee_debut) > quantieme(SL_jour_fin,
                                    SL_mois_fin, SL_annee_fin))
                                {
                                    SL_jour_fin = SL_jour_debut;
                                    SL_mois_fin = SL_mois_debut;
                                    SL_annee_fin = SL_annee_debut;
                                    SL_affiche_champ(5, 0);
                                    SL_affiche_champ(6, 0);
                                    SL_affiche_champ(7, 0);
                                }
                                break;
                            case 3:
                                if (SL_mois_debut == 12)
                                {
                                    if (SL_annee_debut != 2099)
                                    {
                                        SL_mois_debut = 1;
                                        SL_annee_debut++;
                                    }
                                }
                                else
                                    SL_mois_debut++;
                                if (SL_annee_debut%4 == 0)
                                    nb_jours[1] = 29;
                                else
                                    nb_jours[1] = 28;
                                if (SL_jour_debut > nb_jours[SL_mois_debut-1])
                                    SL_jour_debut = nb_jours[SL_mois_debut-1];
                                SL_critere_date = 1;
                                SL_affiche_champ(0, 0);
                                SL_affiche_champ(0, 1);
                                SL_affiche_champ(1, 0);
                                SL_affiche_champ(2, 0);
                                SL_affiche_champ(3, 0);
                                SL_affiche_champ(4, 0);
                                if (quantieme(SL_jour_debut, SL_mois_debut,
                                    SL_annee_debut) > quantieme(SL_jour_fin,
                                    SL_mois_fin, SL_annee_fin))
                                {
                                    SL_jour_fin = SL_jour_debut;
                                    SL_mois_fin = SL_mois_debut;
                                    SL_annee_fin = SL_annee_debut;
                                    SL_affiche_champ(5, 0);
                                    SL_affiche_champ(6, 0);
                                    SL_affiche_champ(7, 0);
                                }
                                break;
                            case 4:
                                if (SL_annee_debut != 2099)
                                    SL_annee_debut++;
                                if (SL_annee_debut%4 == 0)
                                    nb_jours[1] = 29;
                                else
                                    nb_jours[1] = 28;
                                if (SL_jour_debut > nb_jours[SL_mois_debut-1])
                                    SL_jour_debut = nb_jours[SL_mois_debut-1];
                                SL_critere_date = 1;
                                SL_affiche_champ(0, 0);
                                SL_affiche_champ(0, 1);
                                SL_affiche_champ(1, 0);
                                SL_affiche_champ(2, 0);
                                SL_affiche_champ(3, 0);
                                SL_affiche_champ(4, 0);
                                if (quantieme(SL_jour_debut, SL_mois_debut,
                                    SL_annee_debut) > quantieme(SL_jour_fin,
                                    SL_mois_fin, SL_annee_fin))
                                {
                                    SL_jour_fin = SL_jour_debut;
                                    SL_mois_fin = SL_mois_debut;
                                    SL_annee_fin = SL_annee_debut;
                                    SL_affiche_champ(5, 0);
                                    SL_affiche_champ(6, 0);
                                    SL_affiche_champ(7, 0);
                                }
                                break;
                            case 5:
                                if (!SL_date_jusqua_fin)
                                {
                                    if (SL_annee_fin%4 == 0)
                                        nb_jours[1] = 29;
                                    else
                                        nb_jours[1] = 28;
                                    if (SL_jour_fin < nb_jours[SL_mois_fin-1])
                                        SL_jour_fin++;
                                    else
                                    {
                                        if (SL_mois_fin == 12)
                                        {
                                            if (SL_annee_fin != 2099)
                                            {
                                                SL_jour_fin = 1;
                                                SL_mois_fin = 1;
                                                SL_annee_fin++;
                                            }
                                        }
                                        else
                                        {
                                            SL_mois_fin++;
                                            SL_jour_fin = 1;
                                        }
                                    }
                                    SL_critere_date = 1;
                                    SL_affiche_champ(0, 0);
                                    SL_affiche_champ(0, 1);
                                    SL_affiche_champ(1, 0);
                                    SL_affiche_champ(5, 0);
                                    SL_affiche_champ(6, 0);
                                    SL_affiche_champ(7, 0);
                                }
                                break;
                            case 6:
                                if (!SL_date_jusqua_fin)
                                {
                                    if (SL_mois_fin == 12)
                                    {
                                        if (SL_annee_fin != 2099)
                                        {
                                            SL_mois_fin = 1;
                                            SL_annee_fin++;
                                        }
                                    }
                                    else
                                        SL_mois_fin++;
                                    if (SL_annee_fin%4 == 0)
                                        nb_jours[1] = 29;
                                    else
                                        nb_jours[1] = 28;
                                    if (SL_jour_fin > nb_jours[SL_mois_fin-1])
                                        SL_jour_fin = nb_jours[SL_mois_fin-1];
                                    SL_critere_date = 1;
                                    SL_affiche_champ(0, 0);
                                    SL_affiche_champ(0, 1);
                                    SL_affiche_champ(1, 0);
                                    SL_affiche_champ(5, 0);
                                    SL_affiche_champ(6, 0);
                                    SL_affiche_champ(7, 0);
                                }
                                break;
                            case 7:
                                if (!SL_date_jusqua_fin)
                                {
                                    if (SL_annee_fin != 2099)
                                        SL_annee_fin++;
                                    if (SL_annee_fin%4 == 0)
                                        nb_jours[1] = 29;
                                    else
                                        nb_jours[1] = 28;
                                    if (SL_jour_fin > nb_jours[SL_mois_fin-1])
                                        SL_jour_fin = nb_jours[SL_mois_fin-1];
                                    SL_critere_date = 1;
                                    SL_affiche_champ(0, 0);
                                    SL_affiche_champ(0, 1);
                                    SL_affiche_champ(1, 0);
                                    SL_affiche_champ(5, 0);
                                    SL_affiche_champ(6, 0);
                                    SL_affiche_champ(7, 0);
                                }
                                break;
                        }
                    else
                        if (SL_y == 1)
                            switch (SL_x)
                            {
                                case 1:
                                    if ( (SL_mois != 12) || (SL_annee != 2099) )
                                    {
                                        if (SL_mois == 12)
                                        {
                                            SL_mois = 1;
                                            SL_annee++;
                                            SL_affiche_champ(2, 1);
                                        }
                                        else
                                            SL_mois++;
                                        SL_critere_date = 2;
                                        SL_affiche_champ(0, 0);
                                        SL_affiche_champ(0, 1);
                                        SL_affiche_champ(1, 0);
                                        SL_affiche_champ(1, 1);
                                    }
                                    break;
                                case 2:
                                    if (SL_annee < 2099)
                                    {
                                        SL_annee++;
                                        SL_critere_date = 2;
                                        SL_affiche_champ(0, 0);
                                        SL_affiche_champ(0, 1);
                                        SL_affiche_champ(1, 0);
                                        SL_affiche_champ(2, 1);
                                    }
                                    break;
                            }
                    break;
                case '-':
                    if (SL_y == 0)
                        switch (SL_x)
                        {
                            case 2:
                                if (SL_annee_debut%4 == 0)
                                    nb_jours[1] = 29;
                                else
                                    nb_jours[1] = 28;
                                if (SL_jour_debut > 1)
                                    SL_jour_debut--;
                                else
                                {
                                    if (SL_mois_debut == 1)
                                    {
                                        if (SL_annee_debut != 1980)
                                        {
                                            SL_jour_debut = 31;
                                            SL_mois_debut = 12;
                                            SL_annee_debut--;
                                        }
                                    }
                                    else
                                    {
                                        SL_mois_debut--;
                                        SL_jour_debut = nb_jours[SL_mois_debut-1];
                                    }
                                }
                                SL_critere_date = 1;
                                SL_affiche_champ(0, 0);
                                SL_affiche_champ(0, 1);
                                SL_affiche_champ(1, 0);
                                SL_affiche_champ(2, 0);
                                SL_affiche_champ(3, 0);
                                SL_affiche_champ(4, 0);
                                break;
                            case 3:
                                if (SL_mois_debut == 1)
                                {
                                    if (SL_annee_debut != 1980)
                                    {
                                        SL_mois_debut = 12;
                                        SL_annee_debut--;
                                    }
                                }
                                else
                                    SL_mois_debut--;
                                if (SL_annee_debut%4 == 0)
                                    nb_jours[1] = 29;
                                else
                                    nb_jours[1] = 28;
                                if (SL_jour_debut > nb_jours[SL_mois_debut-1])
                                    SL_jour_debut = nb_jours[SL_mois_debut-1];
                                SL_critere_date = 1;
                                SL_affiche_champ(0, 0);
                                SL_affiche_champ(0, 1);
                                SL_affiche_champ(1, 0);
                                SL_affiche_champ(2, 0);
                                SL_affiche_champ(3, 0);
                                SL_affiche_champ(4, 0);
                                break;
                            case 4:
                                if (SL_annee_debut != 1980)
                                    SL_annee_debut--;
                                if (SL_annee_debut%4 == 0)
                                    nb_jours[1] = 29;
                                else
                                    nb_jours[1] = 28;
                                if (SL_jour_debut > nb_jours[SL_mois_debut-1])
                                    SL_jour_debut = nb_jours[SL_mois_debut-1];
                                SL_critere_date = 1;
                                SL_affiche_champ(0, 0);
                                SL_affiche_champ(0, 1);
                                SL_affiche_champ(1, 0);
                                SL_affiche_champ(2, 0);
                                SL_affiche_champ(3, 0);
                                SL_affiche_champ(4, 0);
                                break;
                            case 5:
                                if (!SL_date_jusqua_fin)
                                {
                                    if (SL_annee_fin%4 == 0)
                                        nb_jours[1] = 29;
                                    else
                                        nb_jours[1] = 28;
                                    if (SL_jour_fin > 1)
                                        SL_jour_fin--;
                                    else
                                    {
                                        if (SL_mois_fin == 1)
                                        {
                                            if (SL_annee_fin != 1980)
                                            {
                                                SL_jour_fin = 31;
                                                SL_mois_fin = 12;
                                                SL_annee_fin--;
                                            }
                                        }
                                        else
                                        {
                                            SL_mois_fin--;
                                            SL_jour_fin = nb_jours[SL_mois_fin-1];
                                        }
                                    }
                                    SL_critere_date = 1;
                                    SL_affiche_champ(0, 0);
                                    SL_affiche_champ(0, 1);
                                    SL_affiche_champ(1, 0);
                                    SL_affiche_champ(5, 0);
                                    SL_affiche_champ(6, 0);
                                    SL_affiche_champ(7, 0);
                                    if (quantieme(SL_jour_debut, SL_mois_debut,
                                        SL_annee_debut) > quantieme(SL_jour_fin,
                                        SL_mois_fin, SL_annee_fin))
                                    {
                                        SL_jour_debut = SL_jour_fin;
                                        SL_mois_debut = SL_mois_fin;
                                        SL_annee_debut = SL_annee_fin;
                                        SL_affiche_champ(2, 0);
                                        SL_affiche_champ(3, 0);
                                        SL_affiche_champ(4, 0);
                                    }
                                }
                                break;
                            case 6:
                                if (!SL_date_jusqua_fin)
                                {
                                    if (SL_mois_fin == 1)
                                    {
                                        if (SL_annee_fin != 1980)
                                        {
                                            SL_mois_fin = 12;
                                            SL_annee_fin--;
                                        }
                                    }
                                    else
                                        SL_mois_fin--;
                                    if (SL_annee_fin%4 == 0)
                                        nb_jours[1] = 29;
                                    else
                                        nb_jours[1] = 28;
                                    if (SL_jour_fin > nb_jours[SL_mois_fin-1])
                                        SL_jour_fin = nb_jours[SL_mois_fin-1];
                                    SL_critere_date = 1;
                                    SL_affiche_champ(0, 0);
                                    SL_affiche_champ(0, 1);
                                    SL_affiche_champ(1, 0);
                                    SL_affiche_champ(5, 0);
                                    SL_affiche_champ(6, 0);
                                    SL_affiche_champ(7, 0);
                                    if (quantieme(SL_jour_debut, SL_mois_debut,
                                        SL_annee_debut) > quantieme(SL_jour_fin,
                                        SL_mois_fin, SL_annee_fin))
                                    {
                                        SL_jour_debut = SL_jour_fin;
                                        SL_mois_debut = SL_mois_fin;
                                        SL_annee_debut = SL_annee_fin;
                                        SL_affiche_champ(2, 0);
                                        SL_affiche_champ(3, 0);
                                        SL_affiche_champ(4, 0);
                                    }
                                }
                                break;
                            case 7:
                                if (!SL_date_jusqua_fin)
                                {
                                    if (SL_annee_fin != 1980)
                                        SL_annee_fin--;
                                    if (SL_annee_fin%4 == 0)
                                        nb_jours[1] = 29;
                                    else
                                        nb_jours[1] = 28;
                                    if (SL_jour_fin > nb_jours[SL_mois_fin-1])
                                        SL_jour_fin = nb_jours[SL_mois_fin-1];
                                    SL_critere_date = 1;
                                    SL_affiche_champ(0, 0);
                                    SL_affiche_champ(0, 1);
                                    SL_affiche_champ(1, 0);
                                    SL_affiche_champ(5, 0);
                                    SL_affiche_champ(6, 0);
                                    SL_affiche_champ(7, 0);
                                    if (quantieme(SL_jour_debut, SL_mois_debut,
                                        SL_annee_debut) > quantieme(SL_jour_fin,
                                        SL_mois_fin, SL_annee_fin))
                                    {
                                        SL_jour_debut = SL_jour_fin;
                                        SL_mois_debut = SL_mois_fin;
                                        SL_annee_debut = SL_annee_fin;
                                        SL_affiche_champ(2, 0);
                                        SL_affiche_champ(3, 0);
                                        SL_affiche_champ(4, 0);
                                    }
                                }
                                break;
                        }
                    else
                        if (SL_y == 1)
                            switch (SL_x)
                            {
                                case 1:
                                    if ( (SL_mois != 1) || (SL_annee != 1980) )
                                    {
                                        if (SL_mois == 1)
                                        {
                                            SL_mois = 12;
                                            SL_annee--;
                                            SL_affiche_champ(2, 1);
                                        }
                                        else
                                            SL_mois--;
                                        SL_critere_date = 2;
                                        SL_affiche_champ(0, 0);
                                        SL_affiche_champ(0, 1);
                                        SL_affiche_champ(1, 0);
                                        SL_affiche_champ(1, 1);
                                    }
                                    break;
                                case 2:
                                    if (SL_annee > 1980)
                                    {
                                        SL_annee--;
                                        SL_critere_date = 2;
                                        SL_affiche_champ(0, 0);
                                        SL_affiche_champ(0, 1);
                                        SL_affiche_champ(1, 0);
                                        SL_affiche_champ(2, 1);
                                    }
                                    break;
                            }
                    break;
                case K_HAUT:
                    if (SL_K_HAUT[SL_y][SL_x] != 0)
                    {
                        Old_x = SL_x;
                        Old_y = SL_y;
                        SL_x = SL_K_HAUT[Old_y][Old_x]%10-1;
                        SL_y = SL_K_HAUT[Old_y][Old_x]/10-1;
                        SL_affiche_champ(Old_x, Old_y);
                        SL_affiche_champ(SL_x, SL_y);
                    }
                    break;
                case K_BAS:
                    if (SL_K_BAS[SL_y][SL_x] != 0)
                    {
                        Old_x = SL_x;
                        Old_y = SL_y;
                        SL_x = SL_K_BAS[Old_y][Old_x]%10-1;
                        SL_y = SL_K_BAS[Old_y][Old_x]/10-1;
                        SL_affiche_champ(Old_x, Old_y);
                        SL_affiche_champ(SL_x, SL_y);
                    }
                    break;
                case K_GAUCHE:
                    if (SL_y == 3)
                    {
                        SL_y = 2;
                        SL_affiche_champ(0, 3);
                        SL_affiche_champ(0, 2);
                    }
                    else
                        if ( (SL_y == 1) && (SL_x == 0) )
                        {
                            SL_y = 0;
                            SL_affiche_champ(0, 1);
                            SL_affiche_champ(0, 0);
                        }
                        else
                            if (SL_x > 0)
                            {
                                SL_x--;
                                SL_affiche_champ(SL_x+1, SL_y);
                                SL_affiche_champ(SL_x, SL_y);
                            }
                    break;
                case K_DROITE:
                    if (SL_x < SL_nb_opt_x[SL_y]-1)
                    {
                        SL_x++;
                        SL_affiche_champ(SL_x-1, SL_y);
                        SL_affiche_champ(SL_x, SL_y);
                    }
                    break;
            }
        }
    }
    print_xy_c(54, 1, LIGHTGRAY, BLUE, " non point(s): ");
    affiche_libelles();
    affiche_touches();
    calculs();
    affiche_barres();
    affiche_ecran();
}

// ----------------------------------------------------------------------------

void imprimer()
{
    efface_barre_selection();
    setcolor(WHITE, MAGENTA);
    print_xy(10,  5, "                                                            ");
    print_xy(10,  6, "    IMPRIMER    ");
    print_xy(10,  7, "                                                            ");
    print_xy(10,  8, "  NOTE: Vous pouvez aussi slectionner des oprations avec  ");
    print_xy(10,  9, "        F5 puis appuyer ensuite sur Ctrl-P pour imprimer    ");
    print_xy(10, 10, "        tout ce qui est affich.                            ");
    print_xy(10, 11, "                                                            ");
    print_xy(10, 12, "  Le dernier mois                                           ");
    print_xy(28, 12, "(%s %d)", nom_mois[op[nb_op-1].mois-1], op[nb_op-1].annee);
    print_xy(10, 13, "  Toutes les oprations                                     ");
    print_xy(10, 14, "                                                            ");

    mon_getch();
    affiche_barres();
    affiche_ecran();
}

// ----------------------------------------------------------------------------

int quitter()
{
    int             i, k, pos_bouton;
    unsigned char   texte_bouton_debut[3][6] = { "    O", "    N", "  A"};
    unsigned char   texte_bouton_fin[3][9] = { "ui    ", "on    ", "nnuler  "};
    int             x_bouton_debut[3] = { 17, 34, 51 };
    int             x_bouton_fin[3]   = { 22, 39, 54 };

    if (modif)
    {
        efface_barre_selection();
        setcolor(WHITE, RED);
        print_xy(10,  6, "                                                             ");
        print_xy(10,  7, "    QUITTER    ");
        setcolor(YELLOW, RED);
        print_xy(10,  8, "                                                             ");
        print_xy(10,  9, "  Des modifications ont t apportes depuis la              ");
        print_xy(10, 10, "  dernire sauvegarde.                                       ");
        print_xy(10, 11, "                                                             ");
        print_xy(10, 12, "  Dsirez-vous sauver ces modifications avant de quitter ?   ");
        print_xy(10, 13, "                                                             ");
        print_xy(10, 14, "                                                             ");
        for (i = 0; i < 3; i++)
        {
            if (i == 0)
            {
                print_xy_c(x_bouton_debut[i], 14, YELLOW, GREEN,
                    texte_bouton_debut[i]);
                print_xy_c(x_bouton_fin[i], 14, WHITE, GREEN,
                    texte_bouton_fin[i]);
            }
            else
            {
                print_xy_c(x_bouton_debut[i], 14, YELLOW, BLUE,
                    texte_bouton_debut[i]);
                print_xy_c(x_bouton_fin[i], 14, WHITE, BLUE,
                    texte_bouton_fin[i]);
            }
            print_xy_c(x_bouton_debut[i]+11, 14, BLACK, RED, "");
        }
        print_xy(10, 15, "                            ");
        print_xy(10, 16, "                                                             ");
        print_xy_c(12, 17, BROWN, BLACK, "");
        for (i = 7; i < 18; i++) print_xy(71, i, "");
        pos_bouton = 0;
        _gotoxy(x_bouton_debut[0], 14);
        while (1)
        {
            k = mon_getch();
            switch (k)
            {
                case K_GAUCHE:
                    if (pos_bouton > 0)
                    {
                        print_xy_c(x_bouton_debut[pos_bouton], 14,
                            YELLOW, BLUE, texte_bouton_debut[pos_bouton]);
                        print_xy_c(x_bouton_fin[pos_bouton], 14,
                            WHITE, BLUE, texte_bouton_fin[pos_bouton]);
                        pos_bouton--;
                        print_xy_c(x_bouton_debut[pos_bouton], 14,
                            YELLOW, GREEN, texte_bouton_debut[pos_bouton]);
                        print_xy_c(x_bouton_fin[pos_bouton], 14,
                            WHITE, GREEN, texte_bouton_fin[pos_bouton]);
                        _gotoxy(x_bouton_debut[pos_bouton], 14);
                    }
                    break;
                case K_DROITE:
                    if (pos_bouton < 2)
                    {
                        print_xy_c(x_bouton_debut[pos_bouton], 14,
                            YELLOW, BLUE, texte_bouton_debut[pos_bouton]);
                        print_xy_c(x_bouton_fin[pos_bouton], 14,
                            WHITE, BLUE, texte_bouton_fin[pos_bouton]);
                        pos_bouton++;
                        print_xy_c(x_bouton_debut[pos_bouton], 14,
                            YELLOW, GREEN, texte_bouton_debut[pos_bouton]);
                        print_xy_c(x_bouton_fin[pos_bouton], 14,
                            WHITE, GREEN, texte_bouton_fin[pos_bouton]);
                        _gotoxy(x_bouton_debut[pos_bouton], 14);
                    }
                    break;
                case 'o':
                case 'O':
                    return (sauve_compte());
                case 'n':
                case 'N':
                    return 1;
                case 'a':
                case 'A':
                case K_ECHAP:
                    affiche_ecran();
                    affiche_barres();
                    return 0;
                case K_RETURN:
                    switch (pos_bouton)
                    {
                        case 0:
                            return (sauve_compte());
                        case 1:
                            return 1;
                        case 2:
                            affiche_ecran();
                            affiche_barres();
                            return 0;
                    }
            }
        }
    }
    return 1;
}

// ----------------------------------------------------------------------------

// loop: boucle principale (lecture des caracteres tapes et renvoi vers la
//       fonction correspondante)

void loop()
{
    int     i, k, old_champ, old_op, old_x, old_y;

    affiche_ecran();
    nb_undo = 0;
    nb_max_undo_depasse = 0;

/*    _gotoxy(1, 3);
    print("\x1b[0m\x1b[3;9r\x1b[3;1H\x1b\x4d\x1b[0;0r");
    mon_getch();
    return; */

    while (1)
    {
        k = mon_getch();

        switch (k)
        {
            case 'a':                   // A = annuler un pointage
            case 'A':
                if ( (pos_op < nb_op) && (op[pos_op].pointe) )
                {
                    modif = 1;
                    op[pos_op].pointe = 0;
                    if (nb_undo == NB_MAX_UNDO) decaler_undos();
                    undo[nb_undo].u_code = U_REPOINTER;
                    undo[nb_undo].u_no_op = pos_op;
                    nb_undo++;
                    calculs();
                    if (type_solde == SOLDE_BANQUE)
                        affiche_ecran();
                    else
                    {
                        affiche_champ(pos_op, 1, POS_LIGNE);
                        _gotoxy(x_champ[pos_champ], POS_LIGNE);
                    }
                }
                break;
            case 'b':                   // B = carte bleue pour le libelle
            case 'B':
                if (pos_champ == 2)
                    if (op[pos_op].pointe)
                        son_erreur();
                    else
                        carte_bleue();
                break;
            case 'c':                   // C = cheque suivant pour le libelle
            case 'C':
                if ( (pos_champ == 2) && (op[pos_op].libelle[0] == '\0') )
                    if (op[pos_op].pointe)
                        son_erreur();
                    else
                        cheque_suivant();
                break;
            case 'd':                   // D = debut de l'affichage des op.
            case 'D':
                debut_affichage_op(pos_op);
                break;
            case 4:
                if (deb_op_aff > 0)     // Ctrl-D = restaurer le deb. de l'affichage (deb_op_aff = 0)
                    restaurer_deb_op_aff();
                break;
            #ifdef MSDOS
            case 'e':
            case 'E':                   // Alt-E = basculer EUROS / FRANCS
            #else
            case 201:
            #endif
                if (alt)
                {
                    euro ^= 1;
                    if (euro)
                        print_xy_c(74, 25, BLUE, LIGHTGRAY, " EUROS");
                    else
                        print_xy_c(74, 25, BLUE, LIGHTGRAY, "FRANCS");
                    affiche_statut(1);
                    affiche_pos();
                    affiche_ecran();
                }
                break;
            case 12:                    // Ctrl+L: choix d'un libelle standard
                if (control)
                    if (op[pos_op].pointe)
                        son_erreur();
                    else
                        choix_libelle();
                break;
            case K_INSER:               // INSER = inserer une operation
                if (pos_op < nb_op)
                    insere_operation();
                break;
            case 32:
            //case 'M':
                if (pos_op < nb_op)
                {
                    op[pos_op].couleur ^= 1;
                    if (op[pos_op].couleur == 0)
                    {
                        nb_mark--;
                        somme_mark -= op[pos_op].montant;
                    }
                    else
                    {
                        nb_mark++;
                        somme_mark += op[pos_op].montant;
                    }
                    affiche_op(pos_op);
                    affiche_pos();
                }
                break;
            case 159:                   // Alt-M = inverser le marquage
                nb_mark = 0;
                somme_mark = 0;
                for (i = deb_op_aff; i < nb_op; i++)
                {
                    op[i].couleur ^= 1;
                    if (op[i].couleur != 0)
                    {
                        somme_mark += op[i].montant;
                        nb_mark++;
                    }
                }
                affiche_ecran();
                affiche_pos();
                break;
            case 198:                   // Alt-B: solde reel/solde banque
                if (alt)
                {
                    type_solde ^= 1;
                    //print_xy_c(1, 2, BLUE, CYAN, "    Date     P           Libell             Debit      Crdit    Solde R  ");
                    affiche_libelles();
                    calculs();
                    affiche_ecran();
                }
                break;
            case 'p':                   // P = pointer une operation
            case 'P':
                if ( (pos_op < nb_op) && (!op[pos_op].pointe) )
                {
                    modif = 1;
                    op[pos_op].pointe = 1;
                    if (nb_undo == NB_MAX_UNDO) decaler_undos();
                    undo[nb_undo].u_code = U_DEPOINTER;
                    undo[nb_undo].u_no_op = pos_op;
                    nb_undo++;
                    calculs();
                    if (type_solde == SOLDE_BANQUE)
                        affiche_ecran();
                    else
                    {
                        affiche_champ(pos_op, 1, POS_LIGNE);
                        _gotoxy(x_champ[pos_champ], POS_LIGNE);
                    }
                }
                break;
            case 21:                    // Ctrl+U = modifications en couleur
                if (control)
                    if (nb_undo > 0) modifs_couleur();
                break;
            #ifdef MSDOS
            case 'U':                   // Alt-U = liste des modifications
            #else
            case 217:
            #endif
                if (alt)
                    if (nb_undo > 0) liste_modifs();
                break;
            case K_F1:
                affiche_aide();         // F1 = aide
                break;
            case K_F2:                  // F2 = sauver
                sauve_compte();
                break;
            case K_RETURN:              // RETURN = editer un champ
                if (control)            // Ctrl+Return = recopier champ
                    recopie_champ();
                else
                    if ( (op[pos_op].pointe) && (pos_champ != 2) )
                        son_erreur();
                    else
                        switch (pos_champ)
                        {
                            case 0:
                                if (pos_op == nb_op)
                                // propose la date du jour
                                {
                                    lit_date_systeme();
                                    op[pos_op].jour = jour_systeme;
                                    op[pos_op].mois = mois_systeme;
                                    op[pos_op].annee = annee_systeme;
                                }
                                edite_date();
                                break;
                            case 2:
                                edite_libelle(); break;
                            case 3:
                                edite_montant(); break;
                        }
                    break;
            case K_BAS:                 // fleche bas
                if (control)
                    groupe_suivant();
                else
                    if (alt)
                        echange_op_bas();
                    else
                        if (pos_op < nb_op)
                        {
                            pos_op++;
                            if (y_curseur == 24)
                            {
                                op_debut++;
                                for (i = 0; i < 5; i++)
                                    affiche_champ(pos_op-1, i, 24);
                                scroll(3, 24, SCROLL_HAUT);
                                affiche_op_b(pos_op);
                                //affiche_ecran();
                            }
                            else
                            {
                                affiche_op(pos_op-1);
                                affiche_op(pos_op);
                            }
                        }
                affiche_pos();
                break;
            case K_HAUT:                // fleche haut
                if (control)
                    groupe_precedent();
                else
                    if (alt)
                        echange_op_haut();
                    else
                        if (pos_op > deb_op_aff)
                        {
                            pos_op--;
                            if (y_curseur == 3)
                            {
                                op_debut--;
                                for (i = 0; i < 5; i++)
                                    affiche_champ(pos_op+1, i, 3);
                                scroll(3, 24, SCROLL_BAS);
                                affiche_op_b(pos_op);
                                //affiche_ecran();
                            }
                            else
                            {
                                affiche_op(pos_op+1);
                                affiche_op(pos_op);
                            }
                        }
                affiche_pos();
                break;
            case K_GAUCHE:              // fleche gauche
                if (pos_champ > 0)
                {
                    old_champ = pos_champ;
                    pos_champ--;
                    if (pos_champ == 1) pos_champ--;
                    affiche_champ(pos_op, old_champ, y_curseur);
                    affiche_champ(pos_op, pos_champ, y_curseur);
                }
                break;
            case K_DROITE:              // fleche droite
                if (pos_champ < 3)
                {
                    old_champ = pos_champ;
                    pos_champ++;
                    if (pos_champ == 1) pos_champ++;
                    affiche_champ(pos_op, old_champ, y_curseur);
                    affiche_champ(pos_op, pos_champ, y_curseur);
                }
                break;
            case K_PGUP:                // PgUp
                if (op_debut > deb_op_aff)
                {
                    if (op_debut < 22)
                        { op_debut = 0; pos_op = 0; }
                    else
                        { op_debut -= 22; pos_op -= 22; }
                    affiche_ecran();
                    affiche_pos();
                }
                else
                    if (pos_op > deb_op_aff)
                    {
                        old_op = pos_op;
                        pos_op = deb_op_aff;
                        affiche_op(old_op);
                        affiche_op(pos_op);
                        affiche_pos();
                    }
                break;
            case K_PGDN:                // PgDn
                if (op_debut < nb_op-22)
                {
                    if (op_debut < nb_op-44)
                        { op_debut += 22; pos_op += 22; }
                    else
                        { op_debut = nb_op-21; pos_op = nb_op; }
                    affiche_ecran();
                    affiche_pos();
                }
                else
                    if (pos_op < nb_op)
                    {
                        old_op = pos_op;
                        pos_op = nb_op;
                        affiche_op(old_op);
                        affiche_op(pos_op);
                        affiche_pos();
                    }
                break;
            case K_HOME:                // Home
                if (pos_op > deb_op_aff)
                {
                    op_debut = deb_op_aff;
                    pos_op = deb_op_aff;
                    affiche_ecran();
                    affiche_pos();
                }
                break;
            case K_END:                 // End
                if (pos_op < nb_op)
                {
                    pos_op = nb_op;
                    if (pos_op-deb_op_aff > 21)
                        op_debut = pos_op-21;
                    else
                        op_debut = deb_op_aff;
                    affiche_ecran();
                    affiche_pos();
                }
                break;
            #ifdef MSDOS
            case K_BACKSPACE:           // Alt-BackSpace = Undo
            #else
            case 227:
            #endif
                if (alt)
                    if (nb_undo > 0) _undo();
                break;
            case K_SUPPR:               // Suppr = suppression d'un champ
                if (control)            // Ctrl-Suppr = suppression opration
                {
                    if (!op[pos_op].pointe)
                        efface_operation();
                    else
                        son_erreur();
                }
                else
                    efface_champ();
                break;
            case '+':
                if (alt)                // Alt-"+" = tout marquer
                {
                    nb_mark = 0;
                    somme_mark = 0;
                    for (i = deb_op_aff; i < nb_op; i++)
                    {
                        op[i].couleur = 1;
                        somme_mark += op[i].montant;
                        nb_mark++;
                    }
                    affiche_ecran();
                    affiche_pos();
                }
                else                    // '+' = jour suivant pour la date
                    if (op[pos_op].pointe)
                        son_erreur();
                    else
                        if ( (pos_op < nb_op) && (pos_champ == 0) )
                            jour_suivant();
                break;
            case '-':
                if (alt)                // Alt-"-" = tout demarquer
                {

                    for (i = deb_op_aff; i < nb_op; i++)
                        op[i].couleur = 0;
                    nb_mark = 0;
                    somme_mark = 0;
                    affiche_ecran();
                    affiche_pos();
                }
                else                    // '-' = jour precedent pour la date
                    if (op[pos_op].pointe)
                        son_erreur();
                    else
                        if ( (pos_op < nb_op) && (pos_champ == 0) )
                            jour_precedent();
                break;
            case K_F5:                  // F5 = sous-liste globale
                sous_liste(1);
                break;
            case K_F6:                  // F6 = sous-liste locale
                sous_liste(0);
                break;
            case 16:                    // Ctrl-P = imprimer
                if (control)
                    imprimer();
                break;
            #ifdef MSDOS
            case 'x':
            case 'X':
            #else
            case 220:
            #endif
                if (alt)
                {
                    if (quitter())      // Alt-X = quitter
                        return;
                    _gotoxy(x_champ[pos_champ], POS_LIGNE);
                }
                break;
        }
    }
}

void test()
{
    int     k;

    k = 0;
    while (k != 'q')
    {
        k = mon_getch();
        printf("touche appuyee: %u\r\n", k);
        if (shift) printf("SHIFT appuye\r\n");
        if (control) printf("CONTROL appuye\r\n");
        if (alt) printf("ALT appuye\r\n");
        switch (k)
        {
            case K_F1:print("Touche F1 \r\n"); break;
            case K_F2:print("Touche F2 \r\n"); break;
            case K_F3:print("Touche F3 \r\n"); break;
            case K_F4:print("Touche F4 \r\n"); break;
            case K_F5:print("Touche F5 \r\n"); break;
            case K_F6:print("Touche F6 \r\n"); break;
            case K_F7:print("Touche F7 \r\n"); break;
            case K_F8:print("Touche F8 \r\n"); break;
            case K_F9:print("Touche F9 \r\n"); break;
            case K_F10:print("Touche F10 \r\n"); break;
            case K_F11:print("Touche F11 \r\n"); break;
            case K_F12:print("Touche F12 \r\n"); break;
            case K_INSER:print("Touche INSER \r\n"); break;
            case K_SUPPR:print("Touche SUPPR \r\n"); break;
            case K_HOME:print("Touche HOME \r\n"); break;
            case K_END:print("Touche END \r\n"); break;
            case K_PGUP:print("Touche PGUP \r\n"); break;
            case K_PGDN:print("Touche PGDN \r\n"); break;
        }
    }
}

// ============================================================================

int main(int argc, unsigned char *argv[])
{
    unsigned char   i, j;
    unsigned char   format[10];

    #ifdef MSDOS
    _go32_dpmi_registers regs;

    video = __dpmi_segment_to_descriptor(0xB800);
    #endif

    accents = 1;
    if (argc > 1) traite_params(argc, argv);

    #ifndef MSDOS
    init_ecran_ansi();
    #endif

    setcolor(LIGHTGRAY, BLACK);
    clearscreen();

    charge_compte(argv[0]);
    init_ecran();
    calculs();
    loop();

//    test();

    #ifndef MSDOS
    deinit_ecran_ansi();
    #endif

    message_fin();

//    printf("sizeof(op)+sizeof(undo) = %d+%d = %d\n", sizeof(op), sizeof(undo), sizeof(op)+sizeof(undo));

    return 0;
}
